/* $Id: analyze2.c,v 1.1 1996/11/07 08:02:52 ryo freeze $
 *
 *		\[XR[hWFl[^
 *		̓W[Q
 *		Copyright (C) 1989,1990 K.Abe
 *		All rights reserved.
 *
 */

#include <stdio.h>
#include "estruct.h"
#include "global.h"
#include "label.h"		/* regist_label etc. */
#include "analyze.h"
#include "disasm.h"
#include "offset.h" 	/* depend_address , nearadrs */
#include "etc.h"		/* charout */

USEOPTION		option_y , option_i , option_h;
/*#define		DEBUG	/*	*/


/*
  
  f[^GÃvÖ𔻕ʂ
  vOƔFAhX̐Ԃ
  
*/
extern int		research_data()
{
	address 	pc , nlabel;
	lblmode 	mode , nmode;	 /*  ̗̈̑ */
	lblbuf		*lptr;
	disasm		code;
	int 		rc = 0;
	address 	dummy;

#ifdef	DEBUG
	printf("enter research_data\n" );
#endif

	lptr = next( BeginTEXT );

	pc = lptr->label;
	nmode = lptr->mode;
	mode = PROLABEL;

	while ( pc < Available_text_end ) {
		mode = nmode;
/*		lptr = next( pc + 1 );*/
		lptr = Next( lptr );
		nlabel = lptr->label;
		nmode = lptr->mode;

#ifdef	DEBUG
		printf( "tst %x(%x),%x\n" , pc , mode , nlabel );
#endif
		if ( !((long)pc & 1 ) && isDATLABEL( mode ) && !( mode & FORCE ) &&
			!depend_address( pc ) && ( mode & 0xff ) == UNKNOWN && !isTABLE( mode ) ) {
			dummy = pc;

			if( !option_y ||
			   !( (ULONG)nlabel & 1 ) &&

			   (
					(dis( nlabel - 2 + Ofst,&code,&dummy),
					( code.flag != OTHER && code.flag != UNDEF )) ||

					(dis( nlabel - 4 + Ofst,&code,&dummy) == 4 &&
					( code.flag != OTHER && code.flag != UNDEF )) ||

					(dis( nlabel - 6 + Ofst,&code,&dummy) == 6 && 
					( code.flag != OTHER && code.flag != UNDEF ))
			   )

			){
				if ( analyze( pc , ( option_i ? ANALYZE_IGNOREFAULT : ANALYZE_NORMAL ) ) ) {
					rc++;
#ifdef	DEBUG
					printf( "* maybe program %5x - %5x\n" , pc , nlabel );
#endif
				}
			}
		}
		pc = nlabel;
	}
#ifdef	DEBUG
	printf("exit research_data (rc=%d)\n",rc );
#endif

	return( rc );
}

/*
  
  f[^̈ɂAhXˑ̃f[^o^
  
*/
extern void 	analyze_data()
{
	address 	adrs;
	address 	data_from , data_to;
	
	data_to = BeginTEXT;
	do {
		data_from = next_datlabel( data_to )->label;
		data_to = (address)min( (ULONG)next_prolabel( data_from )->label , (ULONG)Last );

		charout( '#' );
		for ( adrs = data_from ;
			( adrs = nearadrs( adrs ) ) < data_to && adrs < data_to ;
			  adrs += 4 ) {
#ifdef	DEBUG
			printf( "depend_address %x\n" , *(address*)( adrs + Ofst ) );
#endif
			regist_label( *(address*)( adrs + Ofst ) , DATLABEL | UNKNOWN );
		}

		if ( option_h ) {
			for ( adrs = data_from + ( (ULONG)data_from & 1 ) ; adrs < data_to ; adrs += 2 ) {
				if ( *(UWORD*)( adrs + Ofst ) == 0x4e75 )
#ifdef	DEBUG
					printf( "found 0x4e75 in %x\n" , *(address*)( adrs + Ofst ) );
#endif
					regist_label( adrs + 2 , DATLABEL | UNKNOWN );

#ifdef	OSKDIS
				if ( (*(UWORD*)( adrs + Ofst ) & 0xfff8) == 0x4e50)	/* LINK ߂ɒ	*/
					regist_label( adrs, DATLABEL | UNKNOWN );
#endif	/* OSKDIS	*/

			}
		}
	} while ( data_to < Last && adrs != (address)-1 );
}


/*
  
  AhXe[u{
  
*/
extern void 	search_adrs_table()
{
	address 	pc , nlabel;
	lblmode 	mode , nmode;
	lblbuf		*lptr;
	address 	labeltop , label;
	int 		i , count;
	
	lptr = next( BeginTEXT );
	
	pc = lptr->label;
	nmode = lptr->mode;
	
/*	  while ( pc < (address)( Head.text + Head.data ) ) {*/
	while ( pc < (address)( BeginBSS ) ) {
		mode = nmode;
		lptr = next( pc + 1 );
		nlabel = lptr->label;
		nmode = lptr->mode;
/*printf("chk1(%x)",pc);	*/
		if ( isDATLABEL( mode ) ) {
			pc = (address)min( (ULONG)nearadrs( pc ) , (ULONG)nlabel );
/*printf("chk2(%x)",pc);	*/
			labeltop = pc;
			count = 0;
			while ( depend_address( pc ) && pc < nlabel ) {
				pc += 4;
				count++;
			}
/*printf("count(%d)\n",count);	*/
			if ( count >= 3 ) {
#ifdef	DEBUG
				printf( "* found address table at %6x %d\n" , pc - count * 4 , count );
#endif
				for ( i = 0 ; i < count ; i++ ) {
					label = *(address*)( labeltop + i * 4 + Ofst );
					analyze( label , ( option_i ? ANALYZE_IGNOREFAULT : ANALYZE_NORMAL ) );
				}
			}
		}
		pc = nlabel;
	}
}




#ifdef	OSKDIS
/*
  
  hc珉f[^o^
  
*/
extern void analyze_idata()
{
	ULONG	*ofset;
	address	*src, *dst;
	ULONG	siz;

	ofset = (ULONG *)(Top - (ULONG)Head.base + (ULONG)HeadOSK.idata);
	BeginDATA = BeginBSS + *ofset;
	regist_label(BeginDATA, DATLABEL | UNKNOWN);
	regist_label(BeginDATA + ofset[1], DATLABEL | UNKNOWN);
}

/*
  
  hq
  
*/
static void analyze_irefs_sub(codelbl, idatp, ofset, mode)
int	codelbl;
ULONG	*idatp, ofset;
int	mode;
{
	ULONG	idate, *w;
	address	p;

	if (ofset < idatp[0] || ofset >= idatp[0] + idatp[1])
		return;

	p = (address)(&idatp[2]);
	w = (ULONG *)(&p[ofset-idatp[0]]);
	if (codelbl) {
			regist_label(*w, mode);
	}
	else {
			regist_label(BeginBSS + *w, mode);
	}
}

extern void analyze_irefs()
{
	struct REFSTBL {
		UWORD	base;
		UWORD	cnt;
	} *ofset;
	UWORD *p;
	ULONG *idatp;

	idatp = (ULONG *)(Top - (ULONG)Head.base + (ULONG)HeadOSK.idata);
	ofset = (struct REFSTBL *)(Top - (ULONG)Head.base + (ULONG)HeadOSK.irefs);

	while (ofset->cnt) {	/* R[h|C^	*/
		ULONG wk;
		int i;
		wk = BeginBSS + ((ULONG)ofset->base << 16);
		p = (UWORD *)(&ofset[1]);
		for (i = 0; i < ofset->cnt; i++) {
			charout('#');
/*			fprintf(stderr, ":regist_label:%08x\n", BeginBSS + wk + *p);	*/
			regist_label(wk + *p, DATLABEL | LONGSIZE | CODEPTR | FORCE);
			regist_label(wk + *p + 4, DATLABEL | UNKNOWN);
			analyze_irefs_sub(TRUE, idatp, (ULONG)*p, DATLABEL | UNKNOWN);
			p++;
		}
		ofset = (struct REFSTBL *)p;
	}
	ofset++;
	while (ofset->cnt) {	/* f[^|C^	*/
		ULONG wk;
		int i;
		wk = BeginBSS + ((ULONG)ofset->base << 16);
		p = (UWORD *)(&ofset[1]);
		for (i = 0; i < ofset->cnt; i++) {
			charout('#');
/*			fprintf(stderr, ":regist_label:%08x\n", BeginBSS + wk + *p);	*/
			regist_label(wk + *p, DATLABEL | LONGSIZE | DATAPTR | FORCE);
			regist_label(wk + *p + 4, DATLABEL | UNKNOWN);
			analyze_irefs_sub(FALSE, idatp, (ULONG)*p, DATLABEL | UNKNOWN);
			p++;
		}
		ofset = (struct REFSTBL *)p;
	}
}
#endif	/* OSKDIS	*/





