/* $Id: disasm.c,v 2.76 1995/01/07 11:33:16 ryo Exp $
 *
 *	\[XR[hWFl[^
 *	tAZuW[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */

#include <stdio.h>
#include <string.h>
#include "estruct.h"
#include "global.h"
#include "hex.h"
#include "include.h"	/* MAX_CALL_SYMBOL_LEN */
#include "disasm.h"

#ifdef	OSKDIS
#include	"label.h"
#endif	/* OSKDIS	*/

extern int	strncmpi( char* , char* , int );

/* main.c */

extern short	MPU_type;
extern short	MMU_type;
extern short	FPCP_type;
extern short	FPCP_ID[16];

extern int		UndefRegLevel;
extern char		CommentChar;

extern short	sp_a7_flag;



#define BYTE1		(*(unsigned char *)ptr)
#define BYTE2		(*(unsigned char *)(ptr+1))
#define BYTE3		(*(unsigned char *)(ptr+2))
#define BYTE4		(*(unsigned char *)(ptr+3))
#define BYTE5		(*(unsigned char *)(ptr+4))
#define BYTE6		(*(unsigned char *)(ptr+5))
#define WORD1		(*(unsigned short *)ptr)
#define WORD2		(*(unsigned short *)(ptr+2))
#define WORD3		(*(unsigned short *)(ptr+4))
#define LONG05		(*(unsigned long *)(ptr+2))
#define SignBYTE2	(*(signed char *)(ptr+1))
#define SignBYTE4	(*(signed char *)(ptr+3))
#define SignWORD2	(*(signed short *)(ptr+2))
#define SignWORD3	(*(signed short *)(ptr+4))
#define SignLONG05	(*(signed long *)(ptr+2))

/*  AhbVO[h (bitmaped)  */
/*
	Dn ----------------------------------------------------+
	An ---------------------------------------------------+|
	(An) ------------------------------------------------+||
	(An)+ ----------------------------------------------+|||
	-(An) ---------------------------------------------+||||
	d16(An) ------------------------------------------+|||||
	d8(An,ix) ---------------------------------------+||||||
	??? --------------------------------------------+|||||||
	abs.w -----------------------------------------+||||||||
	abs.l ----------------------------------------+|||||||||
	d16(pc) -------------------------------------+||||||||||
	d8(pc,ix) ----------------------------------+|||||||||||
	#imm --------------------------------------+||||||||||||
	                                           |||||||||||||	*/
#define DATAREG		0x00001		/*		-------------------@	*/
#define ADRREG		0x00002		/*		------------------@-	*/
#define ADRIND		0x00004		/*		-----------------@--	*/
#define POSTINC		0x00008		/*		----------------@---	*/
#define PREDEC		0x00010		/*		---------------@----	*/
#define DISPAREG	0x00020		/*		--------------@-----	*/
#define IDXAREG		0x00040		/*		-------------@------	*/
#define ABSW		0x00100		/*		-----------@--------	*/
#define ABSL		0x00200		/*		----------@---------	*/
#define DISPPC		0x00400		/*		---------@----------	*/
#define IDXPC		0x00800		/*		--------@-----------	*/
#define IMMEDIATE	0x01000		/*		-------@------------	*/
#define SRCCR		0x10000		/*		---@----------------	*/
#define MOVEOPT 	0x80000		/*		@-------------------	*/

#define CHANGE		0x0037f		/*		----------@@-@@@@@@@	*/
#define CTRLCHG 	0x00364		/*		----------@@-@@--@--	*/
#define CONTROL 	0x00f64		/*		--------@@@@-@@--@--	*/
#define MEMORY		0x01f7c		/*		-------@@@@@-@@@@@--	*/
#define DATA		0x01f7d		/*		-------@@@@@-@@@@@-@	*/
#define ALL			0x01f7f		/*		-------@@@@@-@@@@@@@	*/


/* private ֐vg^Cv */
private void		op00( address , disasm* );
private void		op01( address , disasm* );
private void		op02( address , disasm* );
private void		op03( address , disasm* );
private void		moveope( address , disasm* );
private void		op04( address , disasm* );
private void		op05( address , disasm* );
private void		op06( address , disasm* );
private void		op07( address , disasm* );
private void		op08( address , disasm* );
private void		op09( address , disasm* );
private void		op0a( address , disasm* );
private void		op0b( address , disasm* );
private void		op0c( address , disasm* );
private void		op0d( address , disasm* );
private void		op0e( address , disasm* );
private void		op0f( address , disasm* );
private void		addsubope( address , disasm* );
INLINE private void logicope( address , disasm* );
private void		bcdope( address , disasm* );
INLINE private void muldivope( address , disasm* );
INLINE private void setcond( disasm* , address );
INLINE private void set18( operand* , int );
INLINE private void setrelative( char* , int , address* );
private void		setreglist( char* , address );
private void		setIMD( disasm* , operand* , address , opesize );
INLINE private void setDn( operand* , int );
INLINE private void setAn( operand* , int );
private void		setAnDisp( disasm* , operand* , int , int );
private void		setEA( disasm* , operand* , address , int );


#ifndef	OSKDIS
char	*OSlabel[ 0x100];
char	*FElabel[ 0x100];
char	*SXlabel[0x1000];
char	OSCallName[16] = "DOS";
char	FECallName[16] = "FPACK";
char	SXCallName[16] = "SXCALL";
#endif	/* OSKDIS	*/

/* oCg߂̕soCg̃`FbN */
boolean Disasm_Exact = TRUE;

/* tAZuꂽԂǂ */
boolean Disasm_String = TRUE;

/* gp Aline , Fline TRAP 𖢒`Ƃ邩 */
boolean Disasm_UnusedTrapUndefined = TRUE;

/* Address Error ̋N閽߂𖢒`Ƃ邩 */
boolean Disasm_AddressErrorUndefined = TRUE;

/* j[jbN啶ŏo͂邩 */
boolean Disasm_MnemonicUpper = FALSE;

/* dbf  dbra Ƃďo͂邩 */
boolean Disasm_Dbra = TRUE;

/* j[jbNȗďo ( cmpi -> cmp etc. ) */
boolean Disasm_MnemonicAbbreviation = FALSE;

/* ! Disasm_UnusedTrapUndefined  SX-Window L */
boolean Disasm_SX_Window = FALSE;

#define SX_WINDOW_EXIT	0xa352

/* 啶s\tO */
static boolean	Cannot_upper0 , Cannot_upper1 /* , Cannot_upper2 , Cannot_upper3 */;

static const int	pow2[16] = {
	1 , 2 , 4 , 8 , 16 , 32 , 64 , 128 ,
	256 , 512 , 1024 , 2048 , 4096 , 8192 , 16384 , 32768 ,
};


static address	PC;

#define IfNeedStr		if( Disasm_String )
#define SETSIZE 		(code->size = code->size2 = (WORD1 >> 6) & 3)
#define DEFAULTSIZE( size ) (code->default_size = size)
#define OPECODE( op )	do{if( Disasm_String ) strcpy( code->opecode , op );}while(0)
#define UNDEFINED		code->flag = UNDEF
#define REJECTBYTESIZE\
	do {\
		if( ( WORD1 & 0x38 ) == 0x8 && code->size == BYTESIZE ) {\
		UNDEFINED;\
		return;\
		}\
	} while(0)
#define FPCOND( code, byte )\
	do{\
		if( byte & 0x20 ){\
			UNDEFINED;\
			return;\
		}else{\
			setfpcond( code, byte );\
		}\
	}while(0)
#define FPOPESET\
	do{\
		if( FPCP_type == 0 || !(ExtensionFlags[ WORD2 & 0x7f ] & FPCP_type ) ){\
			UNDEFINED;\
			return;\
		}else{\
			OPECODE( ExtensionField[ WORD2 & 0x7f ] );\
		}\
	}while(0)
#define MMUCOND( code, byte )\
	do{\
		if( byte & 0x30 ){\
			UNDEFINED;\
			return;\
		}else{\
			setmmucond( code, byte );\
		}\
	}while(0)


/*

  tAZuW[
  ptr (i[)AhX^ƁAcode ɋtAZuʂĂ
  oCg߂Ԃ

  */
extern int	dis( ptr , code , pcptr )
address ptr;
disasm	*code;
address *pcptr; 	/* -> global in this file */
{
	static void (*decode[])( address , disasm* ) = {
	op00 , op01 , op02 , op03 , op04 , op05 , op06 , op07 ,
	op08 , op09 , op0a , op0b , op0c , op0d , op0e , op0f ,
	};
	long	*gptr;

	code->opecode[0] =
	code->op1.operand[0] =
	code->op2.operand[0] =
	code->op3.operand[0] =
	code->op4.operand[0] = '\0';

	code->op1.ea = code->op2.ea = code->op3.ea = code->op4.ea = (adrmode)-1;

	code->op1.opval   = code->op2.opval   = code->op3.opval   = code->op4.opval   =
	code->op1.opval2  = code->op2.opval2  = code->op3.opval2  = code->op4.opval2  =
	code->op1.eaadrs  = code->op2.eaadrs  = code->op3.eaadrs  = code->op4.eaadrs  =
	code->op1.eaadrs2 = code->op2.eaadrs2 = code->op3.eaadrs2 = code->op4.eaadrs2 =
	(address)-1;

	code->op1.exbd = code->op2.exbd = code->op3.exod = code->op4.exod =
	code->op1.exod = code->op2.exod = code->op3.exod = code->op4.exod =
	-1;

	code->op1.labelchange1 = code->op2.labelchange1 =
	code->op3.labelchange1 = code->op4.labelchange1 =
	code->op1.labelchange2 = code->op2.labelchange2 =		/* odp */
	code->op3.labelchange2 = code->op4.labelchange2 =		/* odp */
	FALSE;

/* Cannot_upper2,3 is not used now */
	Cannot_upper0 = Cannot_upper1 /* Cannot_upper2 = Cannot_upper3 */ = FALSE;

#if 0	/* Safe and Normal coding. */
	code->size2 = code->size = NOTHING;
	code->default_size = WORDSIZE;
	code->bytes = 2;
	code->flag = OTHER;
#else	/* Fast but very DANGEROUS coding. */
	gptr = (long*)( &( code->size ) );
	*(opesize*)gptr++ = (opesize)NOTHING;	/* size */
	*(opesize*)gptr++ = (opesize)NOTHING;	/* size2 */
	*(opesize*)gptr++ = (opesize)WORDSIZE;	/* default_size */
	*(int*)gptr++	  = (int)2; 			/* bytes */
	*(opetype*)gptr   = (opetype)OTHER; 	/* flag */
#endif

	PC = *pcptr;

	(*( decode[ BYTE1 >> 4 ] ))( ptr , code );

	if( code->flag == UNDEF ) {
		code->opecode[0] =
		code->op1.operand[0] =
		code->op2.operand[0] =
		code->op3.operand[0] =
		code->op4.operand[0] = '\0';

		IfNeedStr {
			sprintf( code->opecode , ".dc.w\t$%04x\t%c undefined inst." , WORD1, CommentChar );
		}
		code->bytes = 2;
		code->size = code->size2 = NOTHING;
	}
	*pcptr += code->bytes;		/* PC += code->bytes */

	if( Disasm_String && Disasm_MnemonicUpper ) {
	if( !Cannot_upper0 )
		strupr( code->opecode );
	if( !Cannot_upper1 )
		strupr( code->op1.operand );
/*	if( !Cannot_upper2 )*/
		strupr( code->op2.operand );
/*	if( !Cannot_upper3 )*/
		strupr( code->op3.operand );
/*	if( !Cannot_upper4 )*/
		strupr( code->op4.operand );
	}
	return code->bytes;
}


/*	inline functions here... */

INLINE static void	setDn( op , regno )
operand *op;
int regno;
{
	op->ea = DregD;
	IfNeedStr {
		op->operand[0] = 'd';
		op->operand[1] = ( regno & 7 ) + '0';
		op->operand[2] = 0;
	}
}


INLINE static void	setAn( op , regno )
operand *op;
int regno;
{
	op->ea = AregD;
	IfNeedStr {
		op->operand[0] = 'a';
		op->operand[1] = ( regno & 7 ) + '0';
		op->operand[2] = 0;
	}
}


INLINE static void	setRn( op , regno )
operand *op;
int regno;
{
	if( regno & 0x8 ){
		op->ea = AregD;
		IfNeedStr {
			op->operand[0] = 'a';
			op->operand[1] = ( regno & 7 ) + '0';
			op->operand[2] = 0;
		}
	}else{
		op->ea = DregD;
		IfNeedStr {
			op->operand[0] = 'd';
			op->operand[1] = ( regno & 7 ) + '0';
			op->operand[2] = 0;
		}
	}
}


INLINE static void	setFPn( op , regno )
operand *op;
int regno;
{
	op->ea = FPregD;
	IfNeedStr {
		char *p;
		p = op->operand;
		*p++ = 'f';
		*p++ = 'p';
		*p++ = ( regno & 7 ) + '0';
		*p++ = '\0';
	}
}


INLINE static adrmode setFPCRSRlist( op , regno )
operand *op;
int regno;
{
	static char *fpreglist[8] = {
		NULL,
		"fpiar",
		"fpsr",
		"fpsr/fpiar",
		"fpcr",
		"fpcr/fpiar",
		"fpcr/fpsr",
		"fpcr/fpsr/fpiar"
	};

	static adrmode adr[8] = {
		0,
		ALL,
		DATA,
		MEMORY,
		DATA,
		MEMORY,
		MEMORY,
		MEMORY
	};

	op->ea = FPCRSR;
	IfNeedStr {
		strcpy( op->operand, fpreglist[ regno & 7 ] );
	}
	return adr[ regno & 7 ];

}


INLINE static void	setMMUfc( code, op , fc )
disasm	*code;
operand *op;
int fc;
{
	switch( (fc >> 3 ) & 3 ){
	case 0:
		switch( fc & 7 ){
		case 0:
			op->ea = MMUreg;
			strcpy( op->operand, "sfc" );
			break;
		case 1:
			op->ea = MMUreg;
			strcpy( op->operand, "dfc" );
			break;
		default:
			UNDEFINED;
			return;
		}
		break;
	case 1:
		op->ea = DregD;
		op->operand[0] = 'd';
		op->operand[1] = (fc & 7) + '0';
		op->operand[2] = '\0';
		break;
	case 2:
		op->ea = IMMED;
		op->operand[0] = '#';
		itod2( op->operand + 1 , ( fc & 7) );
		break;
	case 3:
		if( MMU_type ){
			op->ea = IMMED;
			op->operand[0] = '#';
			itod2( op->operand + 1 , ( fc & 15 ) );
			break;
		}else{
			UNDEFINED;
			break;
		}
	}
	return;
}


/*	WX^Xg( fmovem ) */
private void	setFPreglist( operandstr , ptr )
char	*operandstr;
address ptr;
{
	unsigned int	i , field;
	boolean flag , already;
	int 	start = 0;
	char	*tmp;

	if( Disasm_String == FALSE )
	return;

	if( ( WORD1 & 0x38 ) == 0x20 )		/* pre-decrement ?   movem Ƃ͋t!! */
		field = BYTE4;
	else{
		field = 0;
		for( i = 0 ; i < 8 ; i++ )
			field |= ( WORD2 & pow2[ i ] ? pow2[ 7 - i ] : 0 );
	}

	for( i = 0 , flag = FALSE , already = FALSE ; i < 9 ; i++ ) {
		if( !flag && field & pow2[ i ] ) {
			start = i;
			flag = TRUE;
		} else {
			if( flag && ( field & pow2[ i ] ) == 0 ) {
				tmp = strend( operandstr );
				if( already )
					*tmp++ = '/';
				*tmp++ = 'f';
				*tmp++ = 'p';
				*tmp++ = start + '0';
				if( start != i - 1 ) {
					*tmp++ = '-';
					*tmp++ = 'f';
					*tmp++ = 'p';
					*tmp++ = i - 1 + '0';
				}
				*tmp = '\0';
				already = TRUE;
				flag = FALSE;
			}
		}
	}
}





/*	and or p ( eor ̓AhbVO[hɈقȂ )	*/
INLINE static void	logicope( ptr , code )
address ptr;
disasm	*code;
{
	SETSIZE;
	if( BYTE1 & 1 ) {
		setDn( &code->op1 , BYTE1 >> 1 );
		setEA( code , &code->op2 , ptr , MEMORY & CHANGE );
	} else {
		setEA( code , &code->op1 , ptr , DATA );
		setDn( &code->op2 , BYTE1 >> 1 );
	}
}


/*	mul div p	*/
INLINE static void	muldivope( ptr , code )
address ptr;
disasm	*code;
{
	if( BYTE1 & 1 )
		strcat( code->opecode , "s" );
	else
		strcat( code->opecode , "u" );

	code->size = code->size2 = WORDSIZE;
	setEA( code , &code->op1 , ptr , DATA );
	setDn( &code->op2 , BYTE1 >> 1 );
}


/*	OtH[ mul div p	*/
INLINE static void	longmuldivope( ptr , code )
address ptr;
disasm	*code;
{
	code->size = code->size2 = LONGSIZE;
	code->bytes = 4;

	setEA( code , &code->op1 , ptr , DATA );

	strcpy( code->op2.operand , "dh:dl" );
	code->op2.operand[1]  = (( WORD2      ) & 7 ) + '0';
	code->op2.operand[4]  = (( BYTE3 >> 4 ) & 7 ) + '0';

}


/*	pack, unpack p	*/
INLINE static void	packope( ptr , code )
address ptr;
disasm	*code;
{
	if( WORD1 & 8 ){
		IfNeedStr {
			strcpy( code->op1.operand , "-(ax)" );
			strcpy( code->op2.operand , "-(ay)" );
			code->op1.operand[3] = ( WORD1 & 7 ) + '0';
			code->op2.operand[3] = ( ( BYTE1 >> 1 ) & 7 ) + '0';
		}
		code->op1.ea = code->op2.ea = AregIDPD;
	}else{
		IfNeedStr {
			strcpy( code->op1.operand , "dx" );
			strcpy( code->op2.operand , "dy" );
			code->op1.operand[1] = ( WORD1 & 7 ) + '0';
			code->op2.operand[1] = ( ( BYTE1 >> 1 ) & 7 ) + '0';
		}
		code->op1.ea = code->op2.ea = DregD;
	}
	setIMD( code , &code->op3 , ptr , WORDSIZE );
	code->op3.ea = IMMED;
}


/*	ccp	*/
INLINE static void	setcond( code , ptr )
disasm	*code;
address ptr;
{
	static char *cond[16] = {
	"t"  , "f"	, "hi" , "ls" , "cc" , "cs" , "ne" , "eq" ,
	"vc" , "vs" , "pl" , "mi" , "ge" , "lt" , "gt" , "le"
	};

	IfNeedStr {
		strcat( code->opecode , cond[ BYTE1 & 0xf ] );
	}
}


/*	Rv ccp	*/
INLINE static void	setfpcond( code, predicate )
disasm	*code;
unsigned char predicate;
{
	static char *cond[32] = {
		 "f"	, "eq"	, "ogt"	, "oge"	, "olt"	, "ole"	, "ogl"	, "or"	,
		 "un"	, "ueq"	, "ugt"	, "uge"	, "ult"	, "ule"	, "ne"	, "t"	,
		 "sf"	, "seq"	, "gt"	, "ge"	, "lt"	, "le"	, "gl"	, "gle"	,
		 "ngle"	, "ngl"	, "nle"	, "nlt"	, "nge"	, "ngt"	, "sne"	, "st"
	};

	strcat( code->opecode , cond[ predicate & 0x1f ] );
}


/*	68851 ccp	*/
INLINE static void	setmmucond( code, predicate )
disasm	*code;
unsigned char predicate;
{
	static char *cond[16] = {
			"bs" ,	"bc" ,	"ls" ,	"lc" ,	"ss" ,	"sc" ,	"as" ,	"ac" ,
			"ws" ,	"wc" ,	"is" ,	"ic" ,	"gs" ,	"gc" ,	"cs" ,	"cc"
	};

	strcat( code->opecode , cond[ predicate & 0x0f ] );
}



/*	#0 - #7 p	*/
INLINE static void	set07( op , num )
operand *op;
int num;
{
	op->ea = IMMED;
	IfNeedStr {
		op->operand[0] = '#';
		op->operand[1] = (num & 7) + '0';
		op->operand[2] = 0;
	}
}


/*	addq , subq , bitp #1 ` #8	*/
INLINE static void	set18( op , num )
operand *op;
int num;
{
	op->ea = IMMED;
	IfNeedStr {
		num &= 7;
		op->operand[0] = '#';
		op->operand[1] = ( num ? num + '0' : '8' );
		op->operand[2] = 0;
	}
}

/*	Εp	*/
INLINE static void	setrelative( optr , disp , opval )
char	*optr;
int 	disp;
address *opval;
{
	*opval = PC + 2 + (WORD)disp;
	IfNeedStr {
		itox8d( optr , (LONG)*opval );
	}
}


/*	Εp(4byteR[h(Rv)p)	*/
INLINE static void	setrelative4( optr , disp , opval )
char	*optr;
int 	disp;
address *opval;
{
	*opval = PC + 4 + (WORD)disp;
	IfNeedStr {
		itox8d( optr , (LONG)*opval );
	}
}


/* O[h */
INLINE static void	setlongrelative( optr , disp , opval )
char	*optr;
int 	disp;
address *opval;
{
	*opval = PC + 2 + disp;
	IfNeedStr {
		itox8d( optr , (LONG)*opval );
	}
}



/*	functions to decode machine instruction op00 - op0f */

private void	op00( ptr , code )
address ptr;
disasm	*code;
{
	static char *opcode01[4] = {
	"btst" , "bchg" , "bclr" , "bset"
	};

	if( ( WORD1 & 0x09c0 ) == 0x00c0 && ( BYTE1 & 0x06 ) != 6 ){
		if( MPU_type < 20 ){ UNDEFINED; return; }
		if( ( WORD2 & 0x0fff ) == 0x0000 ){
			OPECODE( "cmp2" );
			code->default_size = WORDSIZE;
			code->size = code->size2 = ( BYTE1 >> 1 ) & 0x03;
			code->bytes = 4;
			setEA( code , &code->op1 , ptr , DATA );
			setRn( &code->op2 , BYTE3 >> 4 );
			return;
		}else if( ( WORD2 & 0x0fff ) == 0x0800 ){
			OPECODE( "chk2" );
			code->default_size = WORDSIZE;
			code->size = code->size2 = ( BYTE1 >> 1 ) & 0x03;
			code->bytes = 4;
			setEA( code , &code->op1 , ptr , DATA );
			setRn( &code->op2 , BYTE3 >> 4 );
			return;
		}
	}


	if( ( WORD1 & 0x138 ) == 0x108 ) {
		OPECODE( "movep" );
		code->size = code->size2 = ( WORD1 & 0x40 ? LONGSIZE : WORDSIZE );
		if( WORD1 & 0x80 ) {
			setDn( &code->op1 , BYTE1 >> 1 );
			setAnDisp( code , &code->op2 , WORD1 & 7 , WORD2 );
		} else {
			setAnDisp( code , &code->op1 , WORD1 & 7 , WORD2 );
			setDn( &code->op2 , BYTE1 >> 1 );
		}
		return;
	}

	if( ( WORD1 & 0x9c0 ) == 0x8c0 && (BYTE1 & 0x06 ) != 0 &&
	    ( WORD2 & 0xfe38 ) == 0x0000 ){

		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "cas" );
		IfNeedStr {
			strcpy( code->op1.operand , "dn" );
			strcpy( code->op2.operand , "dn" );
			code->op1.operand[1] = ( WORD2 & 7 ) + '0';
			code->op2.operand[1] = (( WORD2 >> 6 ) & 7 ) + '0';
		}
		code->bytes = 4;
		code->op1.ea = code->op2.ea = DregD;
		setEA( code , &code->op3 , ptr , CHANGE ^ DATAREG ^ ADRREG ) ;
		code->size = code->size2 = ((BYTE1 >> 1) & 3)-1;	/* TCYlʂƈႤ */
		return;
	}

	if( ( WORD1 & 0x09ff ) == 0x08fc && ( BYTE1 & 0x06 ) >= 4 &&
	    ( WORD2 & 0x0e38 ) == 0x0000 && ( WORD3 & 0x0e38 ) == 0x0000 ){

		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "cas2" );
		IfNeedStr {
			strcpy( code->op1.operand , "dc:dc" );
			strcpy( code->op2.operand , "du:du" );
			code->op1.operand[1]  = ( WORD2 & 7 ) + '0';
			code->op1.operand[4]  = ( WORD3 & 7 ) + '0';
			code->op2.operand[1]  = (( WORD2 >> 6 ) & 7 ) + '0';
			code->op2.operand[4]  = (( WORD3 >> 6 ) & 7 ) + '0';

			strcpy( code->op3.operand , "(rn):(rn)" );
			code->op3.operand[1]  = ((BYTE3 >> 4) & 8) ? 'a' : 'd';
			code->op3.operand[2]  = ((BYTE3 >> 4) & 7) + '0';
			code->op3.operand[6]  = ((BYTE5 >> 4) & 8) ? 'a' : 'd';
			code->op3.operand[7]  = ((BYTE5 >> 4) & 7) + '0';
		}
		code->op1.ea = code->op2.ea = RegPairD;
		code->op3.ea = RegPairID;

		code->bytes = 6;
		code->size = code->size2 = ((BYTE1 >> 1) & 3)-1;	/* TCYlʂƈႤ */
		return;
	}

	if( ( WORD1 & 0xf00 ) == 0xe00 && ( WORD2 & 0x07ff ) == 0x000 ){
		if( MPU_type < 10 ){ UNDEFINED; return; }
		OPECODE( "moves" );
		SETSIZE;
		code->bytes = 4;
		if( BYTE3 & 0x08 ){
			IfNeedStr {
				code->op1.operand[0]  = ((BYTE3 >> 4) & 8) ? 'a' : 'd';
				code->op1.operand[1]  = ((BYTE3 >> 4) & 7) + '0';
				code->op1.operand[2]  = '\0';
			}
			code->op1.ea = ((BYTE3 >> 4) & 8) ? AregD : DregD;
			setEA( code , &code->op2 , ptr , CHANGE ^ DATAREG ^ ADRREG ) ;
		}else{
			IfNeedStr {
				code->op2.operand[0]  = ((BYTE3 >> 4) & 8) ? 'a' : 'd';
				code->op2.operand[1]  = ((BYTE3 >> 4) & 7) + '0';
				code->op2.operand[2]  = '\0';
			}
			code->op2.ea = ((BYTE3 >> 4) & 8) ? AregD : DregD;
			setEA( code , &code->op1 , ptr , CHANGE ^ DATAREG ^ ADRREG ) ;
		}
		return;
	}

	if( ( BYTE1 & 0x0f ) == 8 ) {	/* btst bchg bclr bset Vtg񐔂immediate */
		if( BYTE3 != 0 ) {
			UNDEFINED;
			return;
		} else {
			OPECODE( opcode01[ (WORD1 >> 6) & 3 ] );
			code->size = code->default_size = (( WORD1 & 0x38 ) ? BYTESIZE : LONGSIZE );
			code->size2 = UNKNOWN;
			setIMD( code , &code->op1 , ptr , BYTESIZE );
			setEA( code , &code->op2 , ptr , DATA ^ IMMEDIATE ) ;
			return;
		}
	}

	if( BYTE1 & 1 ) {			/* shift 񐔂 Dn */
		OPECODE( opcode01[ ( WORD1 >> 6 ) & 3 ] );
		code->size = code->size2 = code->default_size =
			(( WORD1 & 0x38 ) == 0 ) ? LONGSIZE : BYTESIZE;
		setDn( &code->op1 , BYTE1 >> 1 );

		if( ( WORD1 & 0xc0 ) == 0x00 )	/* case btst */
			setEA( code , &code->op2 , ptr , DATA );
		else
			setEA( code , &code->op2 , ptr , DATA & CHANGE );
		return;
	} else {
		static char *opcode00[8] = {
			"or" , "and" , "sub" , "add" , "" , "eor" , "cmp" , ""
			};	/*  { ori, andi, subi, addi, , eori, cmpi, , ...  */

		if( ( WORD1 & 0xc0 ) == 0xc0 ) {
			if( MPU_type == 20 ){
				if( ((WORD1>>3) & 7) > 1 ){
					if( BYTE3 ){
						UNDEFINED;
						return;
					}
					OPECODE( "callm" );
					IfNeedStr {
						code->op1.operand[0] = '#';
						itox2d( code->op1.operand + 1 , BYTE4 );
					}
					code->op1.ea = IMMED;
					code->op1.opval = (address)BYTE4;
					code->bytes += 2;
					setEA( code , &code->op2 , ptr , CONTROL );
				}else{
					OPECODE( "rtm" );
					setRn( &code->op1 , WORD1 );	/* setRn  WORD1 maskĂ */
				}
				return;
			}else{
				UNDEFINED;
				return;
			}
		}

		if( BYTE1 == 8 || BYTE1 == 14 ) {
			UNDEFINED;
			return;
		}
		OPECODE( opcode00[ BYTE1 >> 1 ] );
		SETSIZE;
		setIMD( code , &code->op1 , ptr , code->size );
		if( BYTE1 == 0 || BYTE1 == 2 || BYTE1 == 0xa )	/* ori andi eori */
			setEA( code , &code->op2 , ptr , SRCCR | DATA & CHANGE );
		else if( 20 <= MPU_type && BYTE1 == 0x0c )		/* cmpi */
			setEA( code , &code->op2 , ptr , DATA ^ IMMEDIATE );
		else
			setEA( code , &code->op2 , ptr , DATA & CHANGE );

		if( Disasm_String &&
		    !Disasm_MnemonicAbbreviation ||
		    (
		     Disasm_MnemonicAbbreviation &&
		     ( BYTE1 <= 6 || BYTE1 == 12 ) && code->op2.ea == DregD ||
		     ( BYTE1 == 4 || BYTE1 == 6  ) && (int)code->op1.opval <= 8
		    )
		){
			strcat( code->opecode , "i" );
		}
		return;
	}
	UNDEFINED;
	return;
}


private void	op01( ptr , code )
address ptr;
disasm	*code;
{
	code->size = code->size2 = BYTESIZE;
	moveope( ptr , code );
}


private void	op02( ptr , code )
address ptr;
disasm	*code;
{
	code->size = code->size2 = LONGSIZE;
	moveope( ptr , code );
}


private void	op03( ptr , code )
address ptr;
disasm	*code;
{
	code->size = code->size2 = WORDSIZE;
	moveope( ptr , code );
}


private void	moveope( ptr , code )
address ptr;
disasm	*code;
{
	OPECODE( "move" );
	setEA( code , &code->op1 , ptr , ALL );
	if( code->flag == UNDEF )
		return;
	if( ( WORD1 & 0x1c0 ) == 0x40 ) {		/* moveA ? */
		if( code->size == BYTESIZE ) {
			UNDEFINED;
			return;
		} else {
			if( Disasm_String && !Disasm_MnemonicAbbreviation ){
/*				strcat( code->opecode , "a" );	*/

				code->opecode[4] = 'a';
				code->opecode[5] = '\0';
			}
			setAn( &code->op2 , BYTE1 >> 1 );
			return;
		}
	}
	REJECTBYTESIZE;
	setEA( code , &code->op2 , ptr , DATA & CHANGE | MOVEOPT );


/* move.l #Imm,Dn  moveq.l #Imm,Dn ɉȂ悤... */
	IfNeedStr {
		if( (( WORD1 & 0x31ff ) == 0x203c ) &&				/* move.l #imm,Dn ? */
		    ( (LONG05 < 0x80) || (0xffffff80 <= LONG05) )	/* Immrange? */
		){
			strcat(code->op1.operand,".l");
		}
	}
}


private void	op04( ptr , code )
address ptr;
disasm	*code;
{
	if( ( WORD1 & 0xffc0 ) == 0x4c00 ){
		switch( WORD2 & 0x8ff8 ){
		case 0x0000:
			if( MPU_type < 20 ){ UNDEFINED; return; }

			if( (UndefRegLevel & 1) &&	/* `tB[h 0 or DlƓȂ琳 */
				(WORD2 & 7) != 0 &&
				(WORD2 & 7) != ((BYTE3 >> 4) & 7)
			){
				UNDEFINED;
				return;
			}

			OPECODE( "mulu" );
			code->bytes = 4;
			code->size = code->size2 = LONGSIZE;
			setEA( code , &code->op1 , ptr , DATA );
			setDn( &code->op2 , BYTE3 >> 4 );
			return;
		case 0x0400:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			OPECODE( "mulu" );
			longmuldivope( ptr, code );
			return;
		case 0x0800:
			if( MPU_type < 20 ){ UNDEFINED; return; }

			if( (UndefRegLevel & 1) &&		/* `tB[h 0 or DlƓȂ琳 */
				(WORD2 & 7) != 0 &&
				(WORD2 & 7) != ((BYTE3 >> 4) & 7)
			){
				UNDEFINED;
				return;
			}

			OPECODE( "muls" );
			code->bytes = 4;
			code->size = code->size2 = LONGSIZE;
			setEA( code , &code->op1 , ptr , DATA );
			setDn( &code->op2 , BYTE3 >> 4 );
			return;
		case 0x0c00:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			OPECODE( "muls" );
			longmuldivope( ptr, code );
			return;
		default:
			break;
		}
	}

	if( ( WORD1 & 0xffc0 ) == 0x4c40 ){
		switch( WORD2 & 0x8cf8 ){
		case 0x0000:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			if( (BYTE3 >> 4) == BYTE4 ){
				OPECODE( "divu" );
				code->bytes = 4;
				code->size = code->size2 = LONGSIZE;
				setEA( code , &code->op1 , ptr , DATA );
				setDn( &code->op2 , WORD2 );
				return;
			}else{
				OPECODE( "divul" );
				longmuldivope( ptr, code );
				return;
			}
		case 0x0400:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			OPECODE( "divu" );
			longmuldivope( ptr, code );
			return;
		case 0x0800:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			if( (BYTE3 >> 4) == BYTE4 ){
				OPECODE( "divs" );
				code->bytes = 4;
				code->size = code->size2 = LONGSIZE;
				setEA( code , &code->op1 , ptr , DATA );
				setDn( &code->op2 , WORD2 );
				return;
			}else{
				OPECODE( "divsl" );
				longmuldivope( ptr, code );
				return;
			}
		case 0x0c00:
			if( MPU_type < 20 ){ UNDEFINED; return; }
			OPECODE( "divs" );
			longmuldivope( ptr, code );
			return;
		default:
			break;
		}
	}

	if( ( WORD1 & 0x0ff8 ) == 0x9c0 ){
		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "extb" );
		code->size = code->size2 = LONGSIZE;
		setDn( &code->op1 , WORD1 );
		return;
	}

	if(( WORD1 & 0x1c0 ) == 0x1c0 ){
		OPECODE( "lea" );
		code->size = code->default_size = LONGSIZE;
		code->size2 = UNKNOWN;
		setEA( code , &code->op1 , ptr , CONTROL );
		setAn( &code->op2 , BYTE1 >> 1 );
		return;
	}

	if(( WORD1 & 0x140 ) == 0x100 ){
		OPECODE( "chk" );
		code->default_size = WORDSIZE;
		if( ( WORD1 & 0x80 ) == 0x80 ){
			code->size = code->size2 = WORDSIZE;
		}else if( 20 <= MPU_type && ( WORD1 & 0x80 ) == 0x00 ){
			code->size = code->size2 = LONGSIZE;
		}else{
			UNDEFINED;
			return;
		}
		setEA( code , &code->op1 , ptr , DATA );
		setDn( &code->op2 , BYTE1 >> 1 );
		return;
	}
	if( BYTE1 == 0x4e ) {
		if( 0x70 <= BYTE2 && BYTE2 <= 0x77 ) {
			static char *opecode[8] = {
			"reset" , "nop" , "stop" , "rte" , "rtd" , "rts" , "trapv" , "rtr"
			};
			if( MPU_type < 20 && BYTE2 == 0x74 ){ UNDEFINED; return; }
			OPECODE( opecode[ BYTE2 - 0x70 ] );
			if( BYTE2 == 0x72 || BYTE2 == 0x74 )
				setIMD( code , &code->op1 , ptr , WORDSIZE );
			if( BYTE2 == 0x73 || BYTE2 == 0x74 || BYTE2 == 0x75 || BYTE2 == 0x77 )
				code->flag = RTSOP;
			return;
		}
		if( ( WORD1 & 0xf0 ) == 0x40 ) {
#ifdef	OSKDIS
		if (BYTE2 & 15) {
			OPECODE( "TCALL" );
			IfNeedStr {
				itox2d( code->op1.operand , BYTE2 & 15 );
			}
			code->op1.ea = IMMED;
			code->op1.opval = (address)( BYTE2 & 15 );

			IfNeedStr {
				itox4d( code->op2.operand , WORD2 );
			}
			code->op2.ea = IMMED;
			code->op2.opval = WORD2;
		}
		else {
			OPECODE( "OS9" );
			IfNeedStr {
				itox4d(code->op1.operand, WORD2);
				code->op1.ea = IMMED;
				code->op1.opval = WORD2;
			}
			if (WORD2 == 0x0006		/* F$Exit	*/
			 || WORD2 == 0x001e		/* F$RTE	*/
			 || WORD2 == 0x002d)	/* F$NProc	*/
				code->flag = RTSOP;
		}
		code->bytes = 4;
	    return;
#else
			OPECODE( "trap" );
			IfNeedStr {
				code->op1.operand[0] = '#';
				itod2( code->op1.operand + 1 , WORD1 & 15 );
			}
			code->op1.ea = IMMED;
			code->op1.opval = (address)( WORD1 & 15 );
			return;
#endif	/* OSKDIS	*/
		}
		if( ( WORD1 & 0xf8 ) == 0x50 ) {
			OPECODE( "link" );				/* [hN */
			if( 20 <= MPU_type )
				code->size = code->default_size = WORDSIZE;
			setAn( &code->op1 , WORD1 );
			/* setIMD( code , &code->op2 , ptr , WORDSIZE );*/
			code->op2.ea = IMMED;
			code->bytes += 2;
			IfNeedStr {
				if( SignWORD2 < 0 )
					sprintf( code->op2.operand , "#-%d" , -WORD2 & 0xffff );
				else
					sprintf( code->op2.operand , "#%d" , WORD2 );
			}
			return;
		}
		if( ( WORD1 & 0xf8 ) == 0x58 ) {
			OPECODE( "unlk" );
			setAn( &code->op1 , WORD1 );
			return;
		}
		if( ( WORD1 & 0xc0 ) == 0xc0 ) {
			OPECODE( "jmp" );
			setEA( code , &code->op1 , ptr , CONTROL );
			if( code->flag == UNDEF )
				return;
			code->jmp = code->op1.opval;
			code->jmpea = code->op1.ea;
			code->flag = JMPOP;
			return;
		}
		if( ( WORD1 & 0xc0 ) == 0x80 ) {
			OPECODE( "jsr" );
			setEA( code , &code->op1 , ptr , CONTROL );
			if( code->flag == UNDEF )
			return;
			code->jmp = code->op1.opval;
			code->jmpea = code->op1.ea;
			code->flag = JSROP;
			return;
		}
		if( ( WORD1 & 0xf0 ) == 0x60 ) {
			OPECODE( "move" );
			code->size = code->size2 = code->default_size = LONGSIZE;
			if( WORD1 & 8 ) {
				IfNeedStr { strcpy( code->op1.operand , "usp" ); }
				setAn( &code->op2 , WORD1 );
			} else {
				setAn( &code->op1 , WORD1 );
				IfNeedStr { strcpy( code->op2.operand , "usp" ); }
			}
			return;
		}

		if( ( WORD1 & 0xfe ) == 0x7a ) {
			char *tempptr;

			if( MPU_type < 10 ){ UNDEFINED; return; }

			OPECODE( "movec" );
			code->size = code->size2 = code->default_size = LONGSIZE;
			code->bytes += 2;

			switch( WORD2 & 0x0fff ){
			case 0x000:
						tempptr = "sfc";	break;
			case 0x001:
						tempptr = "dfc";	break;
			case 0x002:	if( MPU_type < 20 ){ UNDEFINED; return; }
						tempptr = "cacr";	break;
			case 0x003:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "tc";		break;
			case 0x004:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "itt0";	break;
			case 0x005:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "itt1";	break;
			case 0x006:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "dtt0";	break;
			case 0x007:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "dtt1";	break;
			case 0x800:
						tempptr = "usp";	break;
			case 0x801:
						tempptr = "vbr";	break;
			case 0x802:	if( MPU_type < 20 || 40 <= MPU_type ){ UNDEFINED; return; }
						tempptr = "caar";	break;
			case 0x803:	if( MPU_type < 20 ){ UNDEFINED; return; }
						tempptr = "msp";	break;
			case 0x804:	if( MPU_type < 20 ){ UNDEFINED; return; }
						tempptr = "isp";	break;
			case 0x805:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "mmusr";	break;
			case 0x806:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "urp";	break;
			case 0x807:	if( MPU_type < 40 ){ UNDEFINED; return; }
						tempptr = "srp";	break;

			default:
				UNDEFINED;
				return;
			}

			if( WORD1 & 1 ) {
				IfNeedStr {
					strcpy( code->op2.operand , tempptr );
				}
				setRn( &code->op1 , BYTE3>>4 );
				code->op2.ea = CtrlReg;
			} else {
				IfNeedStr {
					strcpy( code->op1.operand , tempptr );
				}
				setRn( &code->op2 , BYTE3>>4 );
				code->op1.ea = CtrlReg;
			}
			return;
		}
	}

	if( ( WORD1 & 0xfb8 ) == 0x880 ) {
		OPECODE( "ext" );
		code->size = code->size2 = ( WORD1 & 0x40 ? LONGSIZE : WORDSIZE );
		setDn( &code->op1 , WORD1 );
		return;
	}

	if( WORD1 == 0x4afc ){
		OPECODE( "illegal" );
		return;
	}

	if( ( WORD1 & 0xb80 ) == 0x880 ) {
		OPECODE( "movem" );
		code->size = code->size2 = ( WORD1 & 0x40 ? LONGSIZE : WORDSIZE );
		code->bytes = 4;
		if( WORD2 == 0 ) {				/* register field empty ? */
			UNDEFINED;
			return;
		}
		if( BYTE1 & 4 ) {
			setEA( code , &code->op1 , ptr , CONTROL | POSTINC );
			setreglist( code->op2.operand , ptr );
		} else {
			setreglist( code->op1.operand , ptr );
			setEA( code , &code->op2 , ptr , CONTROL & CHANGE | PREDEC );
		}
		return;
	}

	switch( WORD1 & 0xff8 ){
	case 0x840:
			OPECODE( "swap" );
		code->size = code->size2 = WORDSIZE;
		setDn( &code->op1 , WORD1 );
		return;
	case 0x848:
		if( MPU_type < 10 ){ UNDEFINED; return; }
		OPECODE( "bkpt" );
		IfNeedStr {
			code->op1.operand[0] = '#';
			code->op1.operand[1] = ( WORD1 & 7 ) + '0';
			code->op1.operand[2] = '\0';
		}
		code->op1.ea = IMMED;
		code->op1.opval = (address)( WORD1 & 7 );
		return;
	case 0x808:
		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "link" );					/* O[hN */
		code->size = LONGSIZE;
		code->default_size = WORDSIZE;
		setAn( &code->op1 , WORD1 );
		code->op2.ea = IMMED;
		code->bytes += 4;
		IfNeedStr {
			if( SignLONG05 < 0 )
				sprintf( code->op2.operand , "#-%d" , -LONG05 );
			else
				sprintf( code->op2.operand , "#%d" , LONG05 );
		}
		return;
	}

	switch( WORD1 & 0xfc0 ) {
	case 0x4c0:
		OPECODE( "move" );						/* move to ccr */
		code->size = code->size2 = WORDSIZE;
		setEA( code , &code->op1 , ptr , DATA );
		IfNeedStr { strcpy( code->op2.operand , "ccr" ); }
		return;
	case 0x6c0:
		OPECODE( "move" );						/* move to sr */
		code->size = code->size2 = WORDSIZE;
		setEA( code , &code->op1 , ptr , DATA );
		IfNeedStr { strcpy( code->op2.operand , "sr" ); }
		return;
	case 0x0c0:
		OPECODE( "move" );						/* move from sr */
		code->size = code->size2 = WORDSIZE;
		IfNeedStr { strcpy( code->op1.operand , "sr" ); }
		setEA( code , &code->op2 , ptr , DATA );
		return;
	case 0x2c0:
		if( MPU_type < 10 ){ UNDEFINED; return; }
		OPECODE( "move" );						/* move from ccr */
		code->size = code->size2 = WORDSIZE;
		IfNeedStr { strcpy( code->op1.operand , "ccr" ); }
		setEA( code , &code->op2 , ptr , DATA );
		return;
	case 0x840:
		OPECODE( "pea" );
		code->size = code->default_size = LONGSIZE;
		code->size2 = UNKNOWN;
		setEA( code , &code->op1 , ptr , CONTROL );
		return;
	case 0xac0:
		OPECODE( "tas" );
		code->size = code->size2 = code->default_size = BYTESIZE;
		setEA( code , &code->op1 , ptr , DATA & CHANGE );
		return;
	case 0x800:
		OPECODE( "nbcd" );
		code->size = code->size2 = code->default_size = BYTESIZE;
		setEA( code , &code->op1 , ptr , DATA & CHANGE );
		return;
	}

	if( ( BYTE1 & 0x0f ) <= 10 && ( BYTE1 & 1 ) == 0 ){
		static char *opecode[6] = {
			"negx" , "clr" , "neg" , "not" , "" , "tst"			/*  "" = "nbcd"  */
		};
		if( ( BYTE1 & 0x0f ) == 8 ) {
			UNDEFINED;
			return;
		}
		switch( ( BYTE1 & 0x0f ) >> 1 ){
		case 0:							/* negx */
		case 1:							/* clr  */
		case 2:							/* neg  */
		case 3:							/* not  */
			OPECODE( opecode[ ( BYTE1 & 15 ) >> 1 ] );
			SETSIZE;
			setEA( code , &code->op1 , ptr , DATA & CHANGE );
			return;
		case 4:							/* nbcd */
			UNDEFINED;		/* ɂ͗nYȂ */
			return;
		case 5:							/* tst */
/*			OPECODE( opecode[ ( BYTE1 & 15 ) >> 1 ] );	*/
			OPECODE( "tst" );
			SETSIZE;
			if( 20 <= MPU_type && WORD1 & 0xc0 )			/* size0b11̎tas() */
				setEA( code , &code->op1 , ptr , ALL );		/* word, longword */
			else
				setEA( code , &code->op1 , ptr , DATA );	/* byte or 68000,008,010 */
			return;
		}
	}

	UNDEFINED;
	return;
}


private void	op05( ptr , code )
address ptr;
disasm	*code;
{
	if( ( BYTE2 >> 3 ) == 0x19 ) {			/* DBcc ? */
		OPECODE( "db" );

		if( Disasm_Dbra && ( BYTE1 & 0xf ) == 1 )
			OPECODE( "dbra" );
		else
			setcond( code , ptr );

		setDn( &code->op1 , WORD1 );
		setrelative( code->op2.operand , SignWORD2 , &( code->op2.opval ) );
		code->jmp = code->op2.opval;
		code->jmpea = code->op2.ea = PCDISP;
		code->op2.labelchange1 = TRUE;
#ifdef	OSKDIS
	code->size = NOTHING;	/* OS-9/680x0 ̃AZuir68jł DBcc ɃTCY	*/
	code->size2 = WORDSIZE;	/* tƃG[ɂȂ邽						*/
#else
		code->size = code->size2 = WORDSIZE;
#endif	/* OSKDIS	*/
		code->bytes = 4;
		code->flag = BCCOP;
		return;
	}

	if( ( WORD1 & 0xf8 ) == 0xf8 && (0xfa <= BYTE2) && (BYTE2 <= 0xfc) ){
		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "trap" );						/* trapcc */
		setcond( code , ptr );
		code->default_size = NOTHING;
		switch( BYTE2 - 0xfa ){
		case 0:
			code->size = WORDSIZE;
			setIMD( code , &code->op1 , ptr , WORDSIZE );
			break;
		case 1:
			code->size = LONGSIZE;
			setIMD( code , &code->op1 , ptr , LONGSIZE );
			break;
		case 2:
			break;
		}
		return;
	}

	if( ( WORD1 & 0xc0 ) == 0xc0 ) {		/* Scc ? */
		OPECODE( "s" );
		setcond( code , ptr );
		code->size = code->size2 = code->default_size = BYTESIZE;
		setEA( code , &code->op1 , ptr , DATA & CHANGE );
		return;
	}

	if( BYTE1 & 1 )
		OPECODE( "subq" );
	else
		OPECODE( "addq" );

	SETSIZE;
	REJECTBYTESIZE;
	set18( &code->op1 , BYTE1 >> 1 );
	setEA( code , &code->op2 , ptr , CHANGE );
}


private void	op06( ptr , code )
address ptr;
disasm	*code;
{
	switch( BYTE1 & 0x0f ) {
	case 0:
		OPECODE( "bra" );
		code->flag = JMPOP;
		break;
	case 1:
		OPECODE( "bsr" );
		code->flag = JSROP;
		break;
	default:
		OPECODE( "b" );
		setcond( code , ptr );
		code->flag = BCCOP;
		break;
	}
	if( !BYTE2 ) {
		code->bytes = 4;
		code->size = code->size2 = WORDSIZE;
		setrelative( code->op1.operand , SignWORD2 , &( code->op1.opval ) );
	} else if( 20 <= MPU_type && BYTE2 == 0xff ){
		code->bytes = 6;
		code->size = code->size2 = LONGSIZE;
		setlongrelative( code->op1.operand , SignLONG05 , &( code->op1.opval ) );
	}else{
		code->size = code->size2 = SHORTSIZE;
		setrelative( code->op1.operand , SignBYTE2 , &( code->op1.opval ) );
	}
	code->default_size = NOTHING;		/*	*/
	code->jmp = code->op1.opval;
	code->jmpea = code->op1.ea = PCDISP;
	code->op1.labelchange1 = TRUE;
}


private void	op07( ptr , code )
address ptr;
disasm	*code;
{
	if( BYTE1 & 1 ) {
		UNDEFINED;
		return;
	}
	code->size = code->default_size = LONGSIZE;
	code->size2 = UNKNOWN;
	OPECODE( "moveq" );
	IfNeedStr {
		code->op1.operand[0] = '#';
		itox2d( code->op1.operand + 1 , BYTE2 );
	}
	code->op1.ea = IMMED;
	code->op1.opval = (address)BYTE2;
	setDn( &code->op2 , BYTE1 >> 1 );
}


private void	op08( ptr , code )
address ptr;
disasm	*code;
{
	if( ( WORD1 & 0x1f0 ) == 0x100 ) {		/* sbcd ? */
		OPECODE( "sbcd" );
		bcdope( ptr , code );
		return;
	}

	if( ( WORD1 & 0x1f0 ) == 0x140 ) {
		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "pack" );
		packope( ptr , code );
		return;
	}

	if( ( WORD1 & 0x1f0 ) == 0x180 ) {
		if( MPU_type < 20 ){ UNDEFINED; return; }
		OPECODE( "unpk" );
		packope( ptr , code );
		return;
	}


	if( ( WORD1 & 0xc0 ) == 0xc0 ) {
		OPECODE( "div" );
		muldivope( ptr , code );
	} else {
		OPECODE( "or" );
		logicope( ptr , code );
	}
}


private void	op09( ptr , code )
address ptr;
disasm	*code;
{
	OPECODE( "sub" );
	addsubope( ptr , code );
}


#ifdef	OSKDIS
private void	op0a( ptr , code )
address	ptr;
disasm	*code;
{
	if( Disasm_UnusedTrapUndefined ) {
		UNDEFINED;
	}
	else {
		OPECODE( ".dc" );
		IfNeedStr { itox4d( code->op1.operand , WORD1 ); }
		code->size = code->size2 = code->default_size = WORDSIZE;
	}
}
#else
private void	op0a( ptr , code )
address ptr;
disasm	*code;
{
	if( Disasm_UnusedTrapUndefined ) {
		UNDEFINED;
		return;
	}
	if( Disasm_SX_Window ) {
		if( WORD1 == SX_WINDOW_EXIT )
			code->flag = RTSOP;
		if( SXlabel[ WORD1 & 0xfff ] != NULL ) {
			OPECODE( SXCallName );
			IfNeedStr { strcpy( code->op1.operand , SXlabel[ WORD1 & 0xfff ] ); }
			code->size = code->size2 = code->default_size = NOTHING;
			Cannot_upper1 = TRUE;
			return;
		}
	}
	OPECODE( ".dc" );
	IfNeedStr { itox4d( code->op1.operand , WORD1 ); }
	code->size = code->size2 = code->default_size = WORDSIZE;
}
#endif	/* OSKDIS	*/


private void	op0b( ptr , code )
address ptr;
disasm	*code;
{
	if( ( WORD1 & 0xc0 ) == 0xc0 ) {		/* cmpa ? */
		OPECODE( "cmpa" );
		code->size = code->size2 = (( BYTE1 & 1 ) ? LONGSIZE : WORDSIZE );
		setEA( code , &code->op1 , ptr , ALL );
		setAn( &code->op2 , BYTE1 >> 1 );
		return;
	}

	if( ( WORD1 & 0x138 ) == 0x108 ) {		/* cmpm ? */
		IfNeedStr {
			if( Disasm_MnemonicAbbreviation )
				OPECODE( "cmp" );
			else
				OPECODE( "cmpm" );
		}
		SETSIZE;
		IfNeedStr {
			strcpy( code->op1.operand , "(an)+" );
			code->op1.operand[2] = ( WORD1 & 7 ) + '0';
			strcpy( code->op2.operand , "(an)+" );
			code->op2.operand[2] = (( BYTE1 >> 1 ) & 7 ) + '0';
		}
		code->op1.ea = code->op2.ea = AregIDPI;
		return;
	}

	if( ( BYTE1 & 1 ) == 0 ) {
		OPECODE( "cmp" );					/* cmp ? */
		SETSIZE;
		REJECTBYTESIZE;
		setEA( code , &code->op1 , ptr , ALL );
		setDn( &code->op2 , BYTE1 >> 1 );
		return;
	}

	OPECODE( "eor" );						/* eor */
	SETSIZE;
	if( BYTE1 & 1 ) {
		setDn( &code->op1 , BYTE1 >> 1 );
		setEA( code , &code->op2 , ptr , DATA & CHANGE );
		return;
	}

	UNDEFINED;
	return;
}


private void	op0c( ptr , code )
address ptr;
disasm	*code;
{
	int 	tmp;

	if( ( WORD1 & 0x1f0 ) == 0x100 ) {	/* abcd ? */
		OPECODE( "abcd" );
		bcdope( ptr , code );
		return;
	}

	tmp = WORD1 & 0x1f8;
	if( tmp == 0x140 || tmp == 0x148 || tmp == 0x188 ) {
		OPECODE( "exg" );
		code->size = code->size2 = code->default_size = LONGSIZE;
		switch( tmp ) {
		case 0x140:
			setDn( &code->op1 , BYTE1 >> 1 );
			setDn( &code->op2 , WORD1 );
			break;
		case 0x148:
			setAn( &code->op1 , BYTE1 >> 1 );
			setAn( &code->op2 , WORD1 );
			break;
		case 0x188:
			setDn( &code->op1 , BYTE1 >> 1 );
			setAn( &code->op2 , WORD1 );
			break;
		}
		return;
	}

	if( ( WORD1 & 0xc0 ) == 0xc0 )	{
		OPECODE( "mul" );
		muldivope( ptr , code );
		return;
	} else {
		OPECODE( "and" );
		logicope( ptr , code );
		return;
	}

	UNDEFINED;
}


private void	op0d( ptr , code )
address ptr;
disasm	*code;
{
	OPECODE( "add" );
	addsubope( ptr , code );
}


private void	op0e( ptr , code )
address ptr;
disasm	*code;
{
	UWORD	word1and118 , word1andfc0;
	int 	sizen3;

	if( 20 <= MPU_type && ( WORD1 & 0xf8c0 ) == 0xe8c0 && ( BYTE3 & 0x80 ) == 0x00 ){
		static char *opcode[8] = {
			"tst" , "extu" , "chg" , "exts" , "clr" , "ffo" , "set" , "ins"
		};
		static short addressing[8] = {
			    0 ,     1  ,    0  ,     1  ,    0  ,    1  ,    0  ,     2
		};
		OPECODE( "bf" );
		code->bytes = 4;
		strcat( code->opecode , opcode[ BYTE1 & 7 ] );
		switch( addressing[ BYTE1 & 7 ] ){
		case 0:
			code->op2.ea = BitField;
			if( BYTE1 & 7 )	setEA( code , &code->op1 , ptr , CTRLCHG | DATAREG );
			else			setEA( code , &code->op1 , ptr , CONTROL | DATAREG );
			IfNeedStr {
				char *temp = code->op2.operand;
				*temp++ = '{';
				if( BYTE3 & 0x08 ){
					*temp++ = 'd';
					*temp++ = (( WORD2 >> 6 ) & 7 ) + '0';
				}else{
					temp = itod2( temp , ( WORD2 >> 6 ) & 0x1f );
				}
				*temp++ = ':';
				if( WORD2 & 0x20 ){
					*temp++ = 'd';
					*temp++ = ( WORD2 & 7 ) + '0';
				}else{
					if( WORD2 & 0x1f ){
						temp = itod2( temp , ( WORD2 & 0x1f ));
					}else{
						strcpy( temp, "32" );
						temp += 2;
					}
				}
				*temp++ = '}';
				*temp++ = '\0';
			}
			break;
		case 1:
			code->op2.ea = BitField;
			code->op3.ea = DregD;
			setEA( code , &code->op1 , ptr , CONTROL | DATAREG );
			IfNeedStr {
				char *temp = code->op2.operand;
				*temp++ = '{';
				if( BYTE3 & 0x08 ){
					*temp++ = 'd';
					*temp++ = (( WORD2 >> 6 ) & 7 ) + '0';
				}else{
					temp = itod2( temp , ( WORD2 >> 6 ) & 0x1f );
				}
				*temp++ = ':';
				if( WORD2 & 0x20 ){
					*temp++ = 'd';
					*temp++ = ( WORD2 & 7 ) + '0';
				}else{
					if( WORD2 & 0x1f ){
						temp = itod2( temp , ( WORD2 & 0x1f ));
					}else{
						strcpy( temp, "32" );
						temp += 2;
					}
				}
				*temp++ = '}';
				*temp++ = '\0';

				code->op3.operand[0] = 'd';
				code->op3.operand[1] = ( ( BYTE3 >> 4 ) & 7 ) + '0';
				code->op3.operand[2] = '\0';
			}
			break;
		case 2:
			code->op1.ea = DregD;
			code->op3.ea = BitField;
			setEA( code , &code->op2 , ptr , CTRLCHG + DATAREG );
			IfNeedStr {
				char *temp = code->op3.operand;
				*temp++ = '{';
				if( BYTE3 & 0x08 ){
					*temp++ = 'd';
					*temp++ = (( WORD2 >> 6 ) & 7 ) + '0';
				}else{
					temp = itod2( temp , ( WORD2 >> 6 ) & 0x1f );
				}
				*temp++ = ':';
				if( WORD2 & 0x20 ){
					*temp++ = 'd';
					*temp++ = ( WORD2 & 7 ) + '0';
				}else{
					if( WORD2 & 0x1f ){
						temp = itod2( temp , ( WORD2 & 0x1f ));
					}else{
						strcpy( temp, "32" );
						temp += 2;
					}
				}
				*temp++ = '}';
				*temp++ = '\0';

				code->op1.operand[0] = 'd';
				code->op1.operand[1] = ( ( BYTE3 >> 4 ) & 7 ) + '0';
				code->op1.operand[2] = '\0';
			}
			break;
		}
		return;
	}


	if(( WORD1 & 0xc0 ) == 0xc0 ) {
		code->size = code->size2 = WORDSIZE;
		setEA( code ,  &code->op1 , ptr , MEMORY & CHANGE );
	} else {
	if( WORD1 & 0x20 )
		setDn( &code->op1 , BYTE1 >> 1 );
	else
		set18( &code->op1 , BYTE1 >> 1 );
	SETSIZE;
	setDn( &code->op2 , WORD1 );
	}

	word1and118 = WORD1 & 0x118;
	word1andfc0 = WORD1 & 0xfc0;
	sizen3 = (( BYTE2 >> 6 ) != 3 );
	if( word1and118 == 0x100 && sizen3 || word1andfc0 == 0x1c0 )
	OPECODE( "asl" );
	else if( word1and118 == 0x000 && sizen3 || word1andfc0 == 0x0c0 )
	OPECODE( "asr" );
	else if( word1and118 == 0x108 && sizen3 || word1andfc0 == 0x3c0 )
	OPECODE( "lsl" );
	else if( word1and118 == 0x008 && sizen3 || word1andfc0 == 0x2c0 )
	OPECODE( "lsr" );
	else if( word1and118 == 0x118 && sizen3 || word1andfc0 == 0x7c0 )
	OPECODE( "rol" );
	else if( word1and118 == 0x018 && sizen3 || word1andfc0 == 0x6c0 )
	OPECODE( "ror" );
	else if( word1and118 == 0x110 && sizen3 || word1andfc0 == 0x5c0 )
	OPECODE( "roxl" );
	else if( word1and118 == 0x010 && sizen3 || word1andfc0 == 0x4c0 )
	OPECODE( "roxr" );
	else
	UNDEFINED;
}



static char *ExtensionField[128] = {
	"fmove"		, "fint"	, "fsinh"	, "fintrz"	,
	"fsqrt"		, NULL		, "flognp1"	, NULL		,
	"fetoxm1"	, "ftanh"	, "fatan"	, NULL		,
	"fasin"		, "fatanh"	, "fsin"	, "ftan"	,
	"fetox"		, "ftwotox"	, "ftentox"	, NULL		,
	"flogn"		, "flog10"	, "flog2"	, NULL		,
	"fabs"		, "fcosh"	, "fneg"	, NULL		,
	"facos"		, "fcos"	, "fgetexp"	, "fgetman"	,
	"fdiv"		, "fmod"	, "fadd"	, "fmul"	,
	"fsgldiv"	, "frem"	, "fscale"	, "fsglmul"	,
	"fsub"		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	"fsincos"	, "fsincos"	, "fsincos"	, "fsincos"	,
	"fsincos"	, "fsincos"	, "fsincos"	, "fsincos"	,
	"fcmp"		, NULL		, "ftst"	, NULL		,
	NULL		, NULL		, NULL		, NULL		,

	"fsmove"	, "fssqrt"	, NULL		, NULL		,
	"fdmove"	, "fdsqrt"	, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	"fsabs"		, NULL		, "fsneg"	, NULL		,
	"fdabs"		, NULL		, "frneg"	, NULL		,
	"fsdiv"		, NULL		, "fsadd"	, "fsmul"	,
	"fddiv"		, NULL		, "fdadd"	, "fdmul"	,
	"fssub"		, NULL		, NULL		, NULL		,
	"fdsub"		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
	NULL		, NULL		, NULL		, NULL		,
};



/*
	Undefined				+0
	68881ŗL				+1
	68882ŗL				+2
	040ŗL				+4
	060ŗL(^^			+8
	reserved				+16
	reserved				+32
	reserved				+64
	reserved				+128
*/
static unsigned char ExtensionFlags[1+228] = {
	1+2+4 ,	1+2 ,	1+2 ,	1+2 ,
	1+2+4 ,	0 ,		1+2 ,	0 ,
	1+2 ,	1+2 ,	1+2 ,	0 ,
	1+2 ,	1+2 ,	1+2 ,	1+2 ,
	1+2 ,	1+2 ,	1+2 ,	0 ,
	1+2 ,	1+2 ,	1+2 ,	0 ,
	1+2+4 ,	1+2 ,	1+2+4 ,	0 ,
	1+2 ,	1+2 ,	1+2 ,	1+2 ,
	1+2+4 ,	1+2 ,	1+2+4 ,	1+2+4 ,
	1+2+4 ,	1+2 ,	1+2 ,	1+2+4 ,
	1+2+4 ,	0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	1+2 ,	1+2 ,	1+2 ,	1+2 ,
	1+2 ,	1+2 ,	1+2 ,	1+2 ,
	1+2+4 ,	0 ,		1+2+4 ,	0 ,
	0 ,		0 ,		0 ,		0 ,

	4 ,		4 ,		0 ,		0 ,
	4 ,		4 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	4 ,		0 ,		4 ,		0 ,
	4 ,		0 ,		4 ,		0 ,
	4 ,		0 ,		4 ,		4 ,
	4 ,		0 ,		4 ,		4 ,
	4 ,		0 ,		0 ,		0 ,
	4 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0 ,
	0 ,		0 ,		0 ,		0
};



/*
	opecode	FPm,FPn	L	+1		fxxx fpm,fpn Ƃformat݂Ȃꍇ
	opecode	FPm		L	+2		fxxx fpn,fpn  fxxx fpn Ɖ߂ꍇ

	ex)	ftst = 2,  fmove = 1,  fabs = 1+2
*/
static unsigned char ExtensionFormat[128] = {
		1 ,		3 ,		3 ,		3 ,
		3 ,		0 ,		3 ,		0 ,
		3 ,		3 ,		3 ,		0 ,
		3 ,		3 ,		3 ,		3 ,
		3 ,		3 ,		3 ,		0 ,
		3 ,		3 ,		3 ,		0 ,
		3 ,		3 ,		3 ,		0 ,
		3 ,		3 ,		3 ,		3 ,
		1 ,		1 ,		1 ,		1 ,
		1 ,		1 ,		1 ,		1 ,
		1 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		1 ,		1 ,		1 ,		1 ,
		1 ,		1 ,		1 ,		1 ,
		1 ,		0 ,		2 ,		0 ,
		0 ,		0 ,		0 ,		0 ,

		1 ,		3 ,		0 ,		0 ,
		1 ,		3 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		3 ,		0 ,		3 ,		0 ,
		3 ,		0 ,		3 ,		0 ,
		1 ,		0 ,		1 ,		1 ,
		1 ,		0 ,		1 ,		1 ,
		1 ,		0 ,		0 ,		0 ,
		1 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0 ,
		0 ,		0 ,		0 ,		0
};



static char *mmu_regs[16] = {
	"" ,		"" ,		"tt0" ,		"tt1" ,
	"" ,		"" ,		"" ,		"" ,
	"tc" ,		"drp" ,		"srp" ,		"crp" ,
	"cal" ,		"val" ,		"scc" ,		"ac"
};

/* (68000 +1, 68010 +2,) 68020(68851) +4, 68030 +8, 68040 +16, ( 1<<(MPU_type/10) ) */
static char mmu_regs_varid[16] = {
	0 ,			0 ,			8 ,			8 ,
	0 ,			0 ,			0 ,			0 ,
	8 ,			4 ,			4+8 ,		4+8 ,
	4 ,			4 ,			4 ,			4
};

static char mmu_regs_size[16] = {
	0 ,			0 ,			LONGSIZE ,	LONGSIZE ,
	0 ,			0 ,			0 ,			0 ,
	LONGSIZE ,	QUADSIZE ,	QUADSIZE ,	QUADSIZE ,
	BYTESIZE ,	BYTESIZE ,	BYTESIZE ,	WORDSIZE
};




#ifdef	OSKDIS
private void	op0f( ptr , code )
address	ptr;
disasm	*code;
{
	if( Disasm_UnusedTrapUndefined )
		UNDEFINED;
	else {
		OPECODE( "dc" );
		IfNeedStr { itox4d( code->op1.operand , WORD1 ); }
		code->size = code->size2 = WORDSIZE;
	}
}
#else
private void	op0f( ptr , code )
address ptr;
disasm	*code;
{
	if( MPU_type == 40 ){
		switch( BYTE1 ){
		case 0xf4:
			{
				static char *cr040[4] = {
					"nc" , "dc", "ic", "bc"
				};
				int i;

				if( WORD1 & 0x20 ){
					OPECODE( "cpush?" );
					i = 5;
				}else{
					OPECODE( "cinv?" );
					i = 4;
				}
				IfNeedStr {
					code->opecode[i] = "?lpa"[ (WORD1>>3) & 3 ];
					strcpy( code->op1.operand, cr040[ (WORD1>>6) & 3 ] );
				}
				code->op1.ea = CtrlReg;
				switch( (WORD1>>3) & 3 ){
				case 0:
					UNDEFINED;
					return;
				case 1:
				case 2:
					IfNeedStr {
						strcpy( code->op2.operand , "(an)" );
						code->op2.operand[2] = (WORD1 & 3) + '0';
					}
					code->op2.ea = AregID;
				case 3:
					break;
				}
			}
			return;

		case 0xf5:
			if( (WORD1 & 0xe0) == 0 ){
				switch( (WORD1>>3) & 3 ){
				case 0:
					OPECODE( "pflushn" );
					goto pflush_setAn;
				case 1:
					OPECODE( "pflush" );
pflush_setAn:
					IfNeedStr {
						strcpy( code->op1.operand , "(an)" );
						code->op1.operand[2] = (WORD1 & 3) + '0';
					}
					code->op1.ea = AregID;
					break;

				case 2:
					if( WORD1 & 7 ){ UNDEFINED; return; }		/* `reg.field */
					OPECODE( "pflushan" );
					break;

				case 3:
					if( WORD1 & 7 ){ UNDEFINED; return; }		/* `reg.field */
					OPECODE( "pflusha" );
					break;
				}
				return;
			}

			if( (WORD1 & 0xd8) == 0x48 ){
				OPECODE( "ptest?" );
				IfNeedStr {
					code->opecode[5] = (WORD1 & 0x20) ? 'r' : 'w';

					strcpy( code->op1.operand , "(an)" );
					code->op1.operand[2] = (WORD1 & 7) + '0';
				}
				code->op1.ea = AregID;
				return;
			}

			break;

		case 0xf6:
			OPECODE( "move16" );
			switch( (WORD1 >> 3) & 0x1f ){
			case 0:
				code->op2.opval = *(address *)( ptr + code->bytes );
				IfNeedStr {
					strcpy( code->op1.operand , "(an)+" );
					code->op1.operand[2] = ( WORD1 & 7 ) + '0';
					itox8d( code->op2.operand , (LONG)code->op2.opval );
				}
				code->op2.ea = AbLong;
				code->op2.eaadrs = PC + code->bytes;
				code->bytes += 4;
				return;

			case 1:
				code->op1.opval = *(address *)( ptr + code->bytes );
				IfNeedStr {
					strcpy( code->op2.operand , "(an)+" );
					code->op2.operand[2] = ( WORD1 & 7 ) + '0';
					itox8d( code->op1.operand , (LONG)code->op1.opval );
				}
				code->op1.ea = AbLong;
				code->op1.eaadrs = PC + code->bytes;
				code->bytes += 4;
				return;

			case 2:
				code->op2.opval = *(address *)( ptr + code->bytes );
				IfNeedStr {
					strcpy( code->op1.operand , "(an)" );
					code->op1.operand[2] = ( WORD1 & 7 ) + '0';
					itox8d( code->op2.operand , (LONG)code->op2.opval );
				}
				code->op2.ea = AbLong;
				code->op2.eaadrs = PC + code->bytes;
				code->bytes += 4;
				return;

			case 3:
				code->op1.opval = *(address *)( ptr + code->bytes );
				IfNeedStr {
					strcpy( code->op2.operand , "(an)" );
					code->op2.operand[2] = ( WORD1 & 7 ) + '0';
					itox8d( code->op1.operand , (LONG)code->op1.opval );
				}
				code->op1.ea = AbLong;
				code->op1.eaadrs = PC + code->bytes;
				code->bytes += 4;
				return;

			case 4:
				if( (WORD2 & 0x8fff) != 0x8000 ){
					UNDEFINED;
					return;
				}
				IfNeedStr {
					strcpy( code->op1.operand , "(an)+" );
					code->op1.operand[2] = ( WORD1 & 7 ) + '0';
					strcpy( code->op2.operand , "(an)+" );
					code->op2.operand[2] = (( BYTE3 >> 4 ) & 7 ) + '0';
				}
				code->op1.ea = code->op2.ea = AregIDPI;
				code->bytes = 4;
				return;

			default:
				break;
			}
		default:
			break;
		}
	}


	if( ( MMU_type || MPU_type == 30 ) && ((WORD1 & 0xffc0) == 0xf000 ) ){
		switch( (BYTE3 >> 5) & 7 ){
		case 1:
			{
			int pmode = ( (BYTE3 >> 2) & 7 );
			switch( pmode ){
			case 0:
				if( WORD2 & 0x01e0 ){
					UNDEFINED;
					return;
				}
				OPECODE( "pload?" );
				IfNeedStr {
					code->opecode[5] = ( BYTE3 & 2 ) ? 'r' : 'w';
				}
				code->bytes = 4;
				setMMUfc( code, &code->op1 , WORD2 );
				setEA( code, &code->op2, ptr, CONTROL & CHANGE );
				return;
			case 1:
				if( WORD2 != 0x2400 )	break;
				OPECODE( "pflusha" );
				code->bytes = 4;
				return;
			case 2:
			case 3:
				if( !MMU_type )	break;		/* 68020 + 68851 only */
				if( pmode == 2 ){
					if( WORD2 != 0x2800 )	break;
					OPECODE( "pvalid" );
					code->bytes = 4;
					strcpy( code->op1.operand, "val" );
					code->op1.ea = MMUreg;
				}else{
					if( (WORD2 & 0xfff8) != 0x2c00 )	break;
					OPECODE( "pvalid" );
					code->bytes = 4;
					setAn( &code->op1 , WORD2 );
				}
				setEA( code, &code->op2, ptr, CONTROL & CHANGE );
				code->size = code->size2 = code->default_size
				= LONGSIZE;
				return;
			case 4:
			case 6:
				if( MMU_type )
					if( BYTE3 & 2 )	break;		/* 68851 */
				else
					if( BYTE3 & 3 )	break;		/* 68030 */

				OPECODE( "pflush" );
				code->bytes = 4;
				setMMUfc( code, &code->op1 , WORD2 );
				set07( &code->op2, (WORD2 >> 5) );
				if( pmode == 6 )
					setEA( code, &code->op3, ptr, CONTROL & CHANGE );
				return;
			case 5:
			case 7:
				if( !MMU_type || (BYTE3 & 2) )	break;	/* 68020 + 68851 only */
				OPECODE( "pflushs" );
				code->bytes = 4;
				setMMUfc( code, &code->op1 , WORD2 );
				set07( &code->op2, (WORD2 >> 5) );
				if( pmode == 7 )
					setEA( code, &code->op3, ptr, CONTROL & CHANGE );
				return;
			}
			}
			break;

		case 0:
			if( MMU_type ){
				UNDEFINED;
				return;
			}
		case 2:
			if( BYTE4 ){
				UNDEFINED;
				return;
			}

			switch( BYTE3 & 3 ){
			case 0:						/* MEMORY to MMUreg with FLUSH */
			case 2:						/* MMUreg to MEMORY with FLUSH */
				OPECODE( "pmove" );
				break;
			case 1:						/* MEMORY to MMUreg flush disable */
				if( MMU_type ){			/* pmovefd is 68030 only */
					UNDEFINED;
					return;
				}
				OPECODE( "pmovefd" );
				break;
			case 3:						/* MMUreg to MEMORY flush disable */
				UNDEFINED;
				return;
			}

			if( BYTE3 & 2 ){	/* MMUreg to MEMORY */
				int temp = (( BYTE3 >> 2 ) & 7 ) + (( BYTE3 >> 3 ) & 8 );
				if( mmu_regs_varid[ temp ] & ( 1 << (MPU_type/10) ) ){
					strcpy( code->op1.operand, mmu_regs[ temp ] );

					code->size = code->size2 = code->default_size
					= mmu_regs_size[ temp ];
				}else{
					UNDEFINED;
					return;
				}
				code->op1.ea = MMUreg;
				code->bytes = 4;
				setEA( code, &code->op2, ptr, CONTROL & CHANGE );
				return;
			}else{				/* MEMORY to MMUreg */
				int temp = (( BYTE3 >> 2 ) & 7 ) + (( BYTE3 >> 3 ) & 8 );
				if( mmu_regs_varid[ temp ] & ( 1 << (MPU_type/10) ) ){
					strcpy( code->op2.operand, mmu_regs[ temp ] );

					code->size = code->size2 = code->default_size
					= mmu_regs_size[ temp ];
				}else{
					UNDEFINED;
					return;
				}
				code->op2.ea = MMUreg;
				code->bytes = 4;
				setEA( code, &code->op1, ptr, CONTROL & CHANGE );
				return;
			}
		case 3:
			do{
				if( MPU_type == 30 && ( WORD2 & 0xfdff ) == 0x6000 )	break;
				if( MMU_type       && ( WORD2 & 0xe1e3 ) == 0x6000 )	break;
				UNDEFINED;
				return;
			}while(0);

			OPECODE( "pmove" );
			if( BYTE3 & 2 ){
				if( MMU_type ){
					int temp = ((BYTE3 >> 2) & 7);
					switch( temp ){
					case 0:
					case 1:
						if( BYTE4 ){
							UNDEFINED;
							return;
						}
						strcpy( code->op1.operand , temp == 0 ? "psr" : "pcsr" );
						break;
					case 4:
					case 5:
						strcpy( code->op1.operand , temp == 4 ? "badx" : "bacx" );
						code->op1.operand[3] = ( (WORD2 >> 2) & 7 ) + '0';
						break;
					default:
						UNDEFINED;
						return;
					}
				}else{
					strcpy( code->op1.operand , "mmusr" );
				}
				code->size = code->size2 = code->default_size
				= WORDSIZE;
				code->op1.ea = MMUreg;
				code->bytes = 4;
				setEA( code, &code->op2 , ptr, CONTROL & CHANGE );
				return;
			}else{
				if( MMU_type ){
					int temp = ((BYTE3 >> 2) & 7);
					switch( temp ){
					case 0:
					case 1:
						if( BYTE4 ){
							UNDEFINED;
							return;
						}
						strcpy( code->op2.operand , temp == 0 ? "psr" : "pcsr" );
						break;
					case 4:
					case 5:
						strcpy( code->op2.operand , temp == 4 ? "badx" : "bacx" );
						code->op2.operand[3] = ( (WORD2 >> 2) & 7 ) + '0';
						break;
					default:
						UNDEFINED;
						return;
					}
				}else{
					strcpy( code->op2.operand , "mmusr" );
				}
				code->size = code->size2 = code->default_size
				= WORDSIZE;
				code->op2.ea = MMUreg;
				code->bytes = 4;
				setEA( code, &code->op1 , ptr, CONTROL & CHANGE );
				return;
			}
		case 4:
			OPECODE( "ptest?" );
			IfNeedStr {
				code->opecode[5] = ( BYTE3 & 2 ) ? 'r' : 'w';
			}
			code->bytes = 4;
			setMMUfc( code, &code->op1 , WORD2 );
			setEA( code, &code->op2, ptr, CONTROL & CHANGE );
			set07( &code->op3, (BYTE3 >> 2) );
			if( BYTE3 & 1 )
				setAn( &code->op4 , WORD2 >> 5 );
			return;
		case 5:
			if( !MMU_type )			break;		/* 030 ͖` */
			if( WORD2 != 0xa000 )	break;
			OPECODE( "pflushr" );
			code->bytes = 4;
			setEA( code, &code->op1, ptr, MEMORY );
			return;
		case 6:
		case 7:
			break;
		}
	}

	if( MMU_type && (BYTE1 & 0x0e) == 0 ){
		int temp = (( WORD1 >> 6 ) & 7 );
		switch( temp ){
		case 0:			/* ͍ */
			break;
		case 1:			/* PCss, PDBcc, PTRAPcc */
			if( WORD2 & 0xffc0 ){
				UNDEFINED;
				return;
			}
			switch( (WORD1>>3) & 7 ){
			case 1:
				OPECODE( "pdb" );				/* PDBcc */
				IfNeedStr {
					MMUCOND( code, WORD2 );
				}
				setDn( &code->op1 , WORD1 );
				setrelative4( code->op2.operand , SignWORD3 , &( code->op2.opval ) );
				code->jmp = code->op2.opval;
				code->jmpea = code->op2.ea = PCDISP;
				code->op2.labelchange1 = TRUE;
				code->flag = BCCOP;
				code->bytes = 6;
				code->size = code->size2 = WORDSIZE;
				break;
			case 7:
				code->bytes = 4;

				switch( WORD1 & 7 ){
				case 2:
					code->size = WORDSIZE;
					setIMD( code , &code->op1 , ptr+2 , WORDSIZE );
					break;
				case 3:
					code->size = LONGSIZE;
					setIMD( code , &code->op1 , ptr+2 , LONGSIZE );
					break;
				case 4:
					break;
				default:
					UNDEFINED;
					return;
				}
				OPECODE( "ptrap" );				/* PTRAPcc */
				IfNeedStr {
					MMUCOND( code, WORD2 );
				}
				code->default_size = NOTHING;
				break;
			default:
				OPECODE( "ps" );				/* PScc */
				IfNeedStr {
					MMUCOND( code, WORD2 );
				}
				code->bytes = 4;
				code->size = code->size2 = code->default_size = BYTESIZE;
				setEA( code , &code->op1 , ptr , DATA & CHANGE );
				break;
			}
			return;
		case 2:
		case 3:
			OPECODE( "pb" );				/* PBcc */
			IfNeedStr {
				MMUCOND( code, WORD1 );
			}
			switch( temp ){
			case 2:
				code->bytes = 4;
				code->size = code->size2 = WORDSIZE;
				setrelative( code->op1.operand , SignWORD2 , &( code->op1.opval ) );
				break;
			case 3:
				code->bytes = 6;
				code->size = code->size2 = LONGSIZE;
				setlongrelative( code->op1.operand , SignLONG05 , &( code->op1.opval ) );
				break;
			}
			code->default_size = NOTHING;
			code->jmp = code->op1.opval;
			code->jmpea = code->op1.ea = PCDISP;
			code->flag = BCCOP;
			code->op1.labelchange1 = TRUE;
			return;
		case 4:
			OPECODE( "psave" );
			setEA( code , &code->op1 , ptr , CONTROL & CHANGE | PREDEC );
			return;
		case 5:
			OPECODE( "prestore" );
			setEA( code , &code->op1 , ptr , CONTROL | POSTINC );
			return;
		case 6:
		case 7:
		default:
			UNDEFINED;
			return;
		}
	}



/*
			020 ȏ  &&  68881/882 w  &&  LȃRvID?
	040  RvID  1 ?

( -m68040 Ȏ FPCP_type = 4, FPCP_ID[2*1] = 1; ) ɂȂĂ

*/
	if( (20 <= MPU_type) && FPCP_type && FPCP_ID[BYTE1 & 0x0e] ){
		switch( (WORD1 >> 6) & 7 ){
		case 0:						/* fgen */
			{
				switch( BYTE3 >> 5 ){		/* opclass */
				case 0:						/* FPm to FPn */
					if( BYTE2 ){
						UNDEFINED;
						return;
					}
					FPOPESET;
					code->bytes = 4;
					code->size = code->size2 = EXTENDSIZE;
					setFPn( &code->op1 , BYTE3 >> 2 );
					if( (WORD2 & 0x78) == 0x30 ){		/* fsincos */
						strcpy( code->op2.operand , "fpc:fps" );
						code->op2.operand[2] = (WORD2 & 7) + '0';
						code->op2.operand[6] = ((WORD2 >> 7) & 7) + '0';
						return;
					}else{
						if( ExtensionFormat[ WORD2 & 0x7f ] & 1 ){

							if( (ExtensionFormat[ WORD2 & 0x7f ] & 2) &&
							((BYTE3 >> 2) & 7) == ((WORD2 >> 7 ) & 7))
								;			/* f??? fpn */
									/* fxxx fpn,fpn  fxxx fpn ƂȂꍇ */
							else
								setFPn( &code->op2 , WORD2 >> 7 );

						}else{
							if( (UndefRegLevel & 1) &&
							((WORD2 >> 7) & 7) != 0  &&
							((WORD2 >> 7) & 7) != ((BYTE3 >> 2) & 7)
							){
								UNDEFINED;
								return;
							}
						}
						return;
					}
				case 1:						/* undefined, reserved */
					UNDEFINED;
					return;
				case 2:						/* Memory to FPn   or   movecr */
					if( (( BYTE3 >> 2 ) & 7 ) == 7 ){		/* movecr */

						/* 040 ł unsupported */
						if( !(FPCP_type & 3) ){
							UNDEFINED;
							return;
						}

						OPECODE( "fmovecr" );
						code->bytes = 4;
				 		code->size = code->size2 = EXTENDSIZE;
						IfNeedStr {
							code->op1.operand[0] = '#';
							itox2d( code->op1.operand + 1 , WORD2 & 0x7f );
						}
						code->op1.ea = IMMED;
						code->op1.opval = (address)( WORD2 & 0x7f );
						setFPn( &code->op2 , WORD2 >> 7 );
						return;
					}else{									/* Memory to FPn */
						static const FPSIZE2SIZE[7] = {
							LONGSIZE   , SINGLESIZE , EXTENDSIZE ,
							PACKEDSIZE , WORDSIZE   , DOUBLESIZE ,
							BYTESIZE
						};

						static const FPSIZE2SEA[7] = {
							DATA,	DATA,	MEMORY,
							MEMORY,	DATA,	MEMORY,
							DATA
						};

						FPOPESET;
						code->bytes = 4;
				 		code->size = code->size2 = FPSIZE2SIZE[ (BYTE3 >> 2) & 7 ];
						if( !(FPCP_type & 3) && (code->size == PACKEDSIZE) ){
							UNDEFINED;		/* 040 ł packed decimal */
							return;			/* Software Emulation̑Ώ  */
						}
						setEA( code , &code->op1 , ptr , FPSIZE2SEA[ (BYTE3 >> 2) & 7 ] );

						if( (WORD2 & 0x78) == 0x30 ){		/* fsincos */
							strcpy( code->op2.operand , "fpc:fps" );
							code->op2.operand[2] = (WORD2 & 7) + '0';
							code->op2.operand[6] = ((WORD2 >> 7) & 7) + '0';
							return;
						}else{
							if( ExtensionFormat[ WORD2 & 0x7f ] & 1 ){
								setFPn( &code->op2 , WORD2 >> 7 );
							}else{
								if( (WORD2 >> 7) & 7 ){		/* should be zero ... */
									UNDEFINED;
									return;
								}
							}
							return;
						}
					}
				case 3:										/* move FPn to ... */
					OPECODE( "fmove" );
					code->bytes = 4;
					setFPn( &code->op1 , WORD2 >> 7 );
					switch( (BYTE3 >> 2) & 7 ){		/* destination format */
					case 0:		/* Long */
				 		code->size = code->size2 = LONGSIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE );
						break;
					case 1:		/* Single */
				 		code->size = code->size2 = SINGLESIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE );
						break;
					case 2:		/* Extend */
				 		code->size = code->size2 = EXTENDSIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE ^ DATAREG );
						break;
					case 3:		/* Packed with Static K-Factor */
						if( !(FPCP_type & 3) ){
							UNDEFINED;		/* 040 ł packed decimal */
							return;			/* Software Emulation̑Ώ  */
						}
				 		code->size = code->size2 = PACKEDSIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE ^ DATAREG );
/*Static K-FACTOR;*/
						code->op3.ea = KFactor;
						IfNeedStr {
							char *temp = code->op3.operand;
							unsigned short factor = ( WORD2 ) & 0x7f;
							*temp++ = '{';
							*temp++ = '#';
							if( factor > 0x3f ){
								*temp++ = '-';
								factor = -factor + 0x80;
							}

							temp = itod2( temp , factor );
							*temp++ = '}';
							*temp++ = '\0';
						}
						break;
					case 4:		/* Word */
				 		code->size = code->size2 = WORDSIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE );
						break;
					case 5:		/* Double */
				 		code->size = code->size2 = DOUBLESIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE ^ DATAREG );
						break;
					case 6:		/* Byte */
				 		code->size = code->size2 = BYTESIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE );
						break;
					case 7:		/* Packed with Dynamic K-Factor */
						if( !(FPCP_type & 3) ){
							UNDEFINED;		/* 040 ł packed decimal */
							return;			/* Software Emulation̑Ώ  */
						}
				 		code->size = code->size2 = PACKEDSIZE;
						setEA( code , &code->op2 , ptr , DATA & CHANGE ^ DATAREG );
/*Dynamic K-FACTOR;*/
						code->op3.ea = KFactor;
						IfNeedStr {
							char *temp = code->op3.operand;
							*temp++ = '{';
							*temp++ = 'd';
							*temp++ = ((WORD2 >> 4) & 7 ) + '0';
							*temp++ = '}';
							*temp++ = '\0';
						}
						break;
					}
					return;
				case 4:							/* move(m) Mem to FPCR/FPSR,FPIAR */
					{
						adrmode addressing;
						if( ( addressing = setFPCRSRlist( &code->op2 , BYTE3 >> 2 ) ) == 0 ||
						( WORD2 & 0x03ff ) != 0 ){
								UNDEFINED;
								return;
						}
						OPECODE( "fmovem" );
						IfNeedStr {
							switch( (BYTE3 >> 2) & 7 ){
							case 1:
							case 2:
							case 4:
								code->opecode[5] = '\0';	/* fmovem -> fmove */
							case 3:
							case 5:
							case 6:
							case 7:
								break;
							}
						}
						code->bytes = 4;
				 		code->size = code->size2 = LONGSIZE;
						setEA( code , &code->op1 , ptr , addressing );
						return;
					}
				case 5:							/* move(m) FPCR/FPSR,FPIAR to Mem */
					{
						adrmode addressing;
						if( ( addressing = setFPCRSRlist( &code->op1 , BYTE3 >> 2 ) ) == 0 ||
						( WORD2 & 0x03ff ) != 0 ){
								UNDEFINED;
								return;
						}
						OPECODE( "fmovem" );
						IfNeedStr {
							switch( (BYTE3 >> 2) & 7 ){
							case 1:
							case 2:
							case 4:
								code->opecode[5] = '\0';	/* fmovem -> fmove */
							case 3:
							case 5:
							case 6:
							case 7:
								break;
							}
						}
						code->bytes = 4;
				 		code->size = code->size2 = LONGSIZE;
						setEA( code , &code->op2 , ptr , addressing & CHANGE );
						return;
					}
				case 6:									/* fmovem.x Mem to FPCP */
					if( !(BYTE3 & 7) ){
						OPECODE( "fmovem" );			/* from MEMORY to FPCP */
						code->bytes = 4;
				 		code->size = code->size2 = EXTENDSIZE;
						switch( (BYTE3 >> 3) & 3 ){
						case 0:
						case 1:
							UNDEFINED;
							return;
						case 2:
							setFPreglist( code->op2.operand , ptr );
							break;
						case 3:
							if( WORD2 & 0x8f ){
								UNDEFINED;
								return;
							}
							code->op2.ea = DregD;
							code->op2.operand[0] = 'd';
							code->op2.operand[1] = ((WORD2 >> 4) & 7) + '0';
							code->op2.operand[2] = '\0';
						}
						setEA( code , &code->op1 , ptr , CONTROL | POSTINC );
						return;
					}
					break;
				case 7:									/* fmovem.x FPCP to Mem */
					if( !(BYTE3 & 7) ){
						OPECODE( "fmovem" );			/* from FPCP to MEMORY */
						code->bytes = 4;
				 		code->size = code->size2 = EXTENDSIZE;
						switch( (BYTE3 >> 3) & 3 ){
						case 0:
						case 2:
							setFPreglist( code->op1.operand , ptr );
							break;
						case 1:
						case 3:
							if( WORD2 & 0x8f ){
								UNDEFINED;
								return;
							}
							code->op1.ea = DregD;
							code->op1.operand[0] = 'd';
							code->op1.operand[1] = ((WORD2 >> 4) & 7) + '0';
							code->op1.operand[2] = '\0';
						}
						setEA( code , &code->op2 , ptr , CONTROL & CHANGE | PREDEC );
						return;
					}
					break;
				}
			}
			UNDEFINED;
			return;
		case 1:
			if( ( WORD2 & 0xffc0 ) != 0x0000 ){
				UNDEFINED;
				return;
			}else{
				if( ( WORD1 & 0x38 ) == 0x08 ){
					OPECODE( "fdb" );		/* fdbcc */
					IfNeedStr {
						if( Disasm_Dbra && (WORD2 & 0x1f) == 0 ){
							strcat( code->opecode , "ra" );		/*   fdbf  fdbra   */
						}else{
							FPCOND( code, WORD2 );
						}
					}
					setDn( &code->op1 , WORD1 );
					setrelative4( code->op2.operand , SignWORD3 , &( code->op2.opval ) );
					code->jmp = code->op2.opval;
					code->jmpea = code->op2.ea = PCDISP;
					code->op2.labelchange1 = TRUE;
					code->flag = BCCOP;
					code->bytes = 6;
					return;

				}else if( ( WORD1 & 0x38 ) == 0x38 ){
					code->bytes = 4;
					switch( WORD1 & 7 ){
					case 0:
					case 1:
						goto FScc;
					case 5:
					case 6:
					case 7:
						UNDEFINED;
						return;
					case 2:
						code->size = WORDSIZE;
						setIMD( code , &code->op1 , ptr+2 , WORDSIZE );
						break;
					case 3:
						code->size = LONGSIZE;
						setIMD( code , &code->op1 , ptr+2 , LONGSIZE );
						break;
					case 4:
						break;
					}
					OPECODE( "ftrap" );		/* ftrapcc */
					IfNeedStr {
						FPCOND( code, WORD2 );
					}
					code->default_size = NOTHING;
					return;
				}else{
FScc:
					OPECODE( "fs" );		/* fscc */
					IfNeedStr {
						FPCOND( code, WORD2 );
					}
					code->bytes = 4;
					code->size = code->size2 = code->default_size = BYTESIZE;
					setEA( code , &code->op1 , ptr , DATA & CHANGE );
					return;
				}
			}
		case 2:
		case 3:
			if( ( BYTE2 == 0x80 ) && ( WORD2 == 0x00 ) ){
				OPECODE( "fnop" );
				code->bytes = 4;
				return;
			}else{
				OPECODE( "fb" );		/* fbcc */
				IfNeedStr {
					if( (WORD1 & 0x1f) == 15 ){
						strcat( code->opecode , "ra" );
					}else{
						FPCOND( code, WORD1 );
					}
				}
				code->flag = BCCOP;
				if( WORD1 & 0x40 ){
					code->bytes = 6;
					code->size = code->size2 = LONGSIZE;
					setlongrelative( code->op1.operand , SignLONG05 , &( code->op1.opval ) );
				}else{
					code->bytes = 4;
					code->size = code->size2 = WORDSIZE;
					setrelative( code->op1.operand , SignWORD2 , &( code->op1.opval ) );
				}
				code->default_size = NOTHING;
				code->jmp = code->op1.opval;
				code->jmpea = code->op1.ea = PCDISP;
				code->op1.labelchange1 = TRUE;
				return;
			}
		case 4:
			OPECODE( "fsave" );
			setEA( code ,  &code->op1 , ptr , CTRLCHG | PREDEC );
			return;
		case 5:
			OPECODE( "frestore" );
			setEA( code ,  &code->op1 , ptr , CONTROL | POSTINC );
			return;
		case 6:
		case 7:
			UNDEFINED;
			return;
		}
	}


	switch( BYTE1 ){
	case 0xff:
		if( OSlabel[ BYTE2 ] != NULL ){
			OPECODE( OSCallName );
			IfNeedStr {
				strcpy( code->op1.operand , OSlabel[ BYTE2 ] );
				Cannot_upper0 = Cannot_upper1 = TRUE;
			}
			code->size = code->size2 = code->default_size = NOTHING;
/*
			if(	strncmpi( code->op1.operand , "_EXIT" , 5 ) == 0 ||
				strncmpi( code->op1.operand , "_KEEPPR" , 7 ) == 0 ) {
				code->flag = RTSOP;
			}
*/
			/*			_EXIT			_EXIT2			_KEEPPR		*/
			if( BYTE2 == 0x00 || BYTE2 == 0x4c || BYTE2 == 0x31 )
				code->flag = RTSOP;
		}else
			goto not_defined;
		break;
	case 0xfe:
		if( FElabel[ BYTE2 ] != NULL ){
			OPECODE( FECallName );
			IfNeedStr {
				strcpy( code->op1.operand , FElabel[ BYTE2 ] );
				Cannot_upper0 = Cannot_upper1 = TRUE;
			}
			code->size = code->size2 = code->default_size = NOTHING;
		}else
			goto not_defined;
		break;
	not_defined:
	default:
		if( Disasm_UnusedTrapUndefined )
			UNDEFINED;
		else {
			OPECODE( ".dc" );
			IfNeedStr { itox4d( code->op1.operand , WORD1 ); }
			code->size = code->size2 = WORDSIZE;
		}
	break;
	}
}
#endif	/* OSKDIS	*/


/*	add sub p	*/
private void	addsubope( ptr , code )
address ptr;
disasm	*code;
{
	if( ( WORD1 & 0xc0 ) == 0xc0 ) {		/* ???A ? */
		code->size = code->size2 = (( BYTE1 & 1 ) ? LONGSIZE : WORDSIZE );
		setEA( code , &code->op1 , ptr , ALL );
		setAn( &code->op2 , BYTE1 >> 1 );
		if( Disasm_String &&
		   !Disasm_MnemonicAbbreviation ||
		   ( Disasm_MnemonicAbbreviation && code->op1.ea == IMMED &&
			(int)code->op1.opval <= 8 ) )
			strcat( code->opecode , "a" );
		return;
	}

	if( ( WORD1 & 0x130 ) == 0x100 ) {		/* ???X ? */
		strcat( code->opecode , "x" );
		SETSIZE;
		if( WORD1 & 8 ) {
			IfNeedStr {
				strcpy( code->op1.operand , "-(an)" );
				code->op1.operand[3] = ( WORD1 & 7 ) + '0';
				strcpy( code->op2.operand , "-(an)" );
				code->op2.operand[3] = (( BYTE1 >> 1 ) & 7 ) + '0';
			}
			code->op1.ea = code->op2.ea = AregIDPD;
		} else {
			setDn( &code->op1 , WORD1 );
			setDn( &code->op2 , BYTE1 >> 1 );
		}
		return;
	}

	SETSIZE;
	if( BYTE1 & 1 ) {
		setDn( &code->op1 , BYTE1 >> 1 );
		setEA( code , &code->op2 , ptr , MEMORY & CHANGE );
	} else {
		REJECTBYTESIZE;
		setEA( code , &code->op1 , ptr , ALL );
		setDn( &code->op2 , BYTE1 >> 1 );

		IfNeedStr {
			if( (WORD1 & 0x013f) == 0x003c ){			/* add/sub #imm,Dn ? */
				switch( (WORD1>>6) & 3 ){
				case 0:
					if( (0 < WORD2) && (WORD2 < 9) )	strcat(code->op1.operand,".b");
					break;
				case 1:
					if( (0 < WORD2) && (WORD2 < 9) )	strcat(code->op1.operand,".w");
					break;
				case 2:
					if( (0 < LONG05) && (LONG05 < 9) )	strcat(code->op1.operand,".l");
					break;
				}
			}
		}
	}
}


/*	bcd p		*/
private void	bcdope( ptr , code )
address ptr;
disasm	*code;
{
	code->size = code->size2 = code->default_size = BYTESIZE;
	if( WORD1 & 8 ) {
	IfNeedStr {
		strcpy( code->op1.operand , "-(an)" );
		code->op1.operand[3] = ( WORD1 & 7 ) + '0';
		strcpy( code->op2.operand , "-(an)" );
		code->op2.operand[3] = (( BYTE1 >> 1 ) & 7 ) + '0';
	}
	code->op1.ea = code->op2.ea = AregIDPD;
	} else {
	setDn( &code->op1 , WORD1 );
	setDn( &code->op2 , BYTE1 >> 1 );
	}
}


/*	WX^Xg( movem ) */
private void	setreglist( operandstr , ptr )
char	*operandstr;
address ptr;
{
	unsigned int	i , field , field2;
	boolean flag , already;
	int 	start = 0;
	char	*tmp;

	if( Disasm_String == FALSE )
	return;

	if( ( WORD1 & 0x38 ) == 0x20 ) {	/* pre-decrement ? */
	field = 0;
	for( i = 0 ; i < 16 ; i++ )
		field |= ( WORD2 & pow2[ i ] ? pow2[ 15 - i ] : 0 );
	} else
	field = WORD2;

	field2 = field & 0xff;			/* lower 8 bit */
	for( i = 0 , flag = FALSE , already = FALSE ; i < 9 ; i++ ) {
	if( !flag && field2 & pow2[ i ] ) {
		start = i;
		flag = TRUE;
	} else {
		if( flag && ( field2 & pow2[ i ] ) == 0 ) {
		tmp = strend( operandstr );
		if( already )
			*tmp++ = '/';
		*tmp++ = 'd';
		*tmp++ = start + '0';
		if( start != i - 1 ) {
			*tmp++ = '-';
			*tmp++ = 'd';
			*tmp++ = i - 1 + '0';
		}
		*tmp = '\0';
		already = TRUE;
		flag = FALSE;
		}
	}
	}

	field2 = field >> 8;
	for( i = 0 , flag = FALSE ; i < 9 ; i++ ) {
	if( !flag && field2 & pow2[ i ] ) {
		start = i;
		flag = TRUE;
	} else {
		if( flag && ( field2 & pow2[ i ] ) == 0 ) {
		tmp = strend( operandstr );
		if( already )
			*tmp++ = '/';
		*tmp++ = 'a';
		*tmp++ = start + '0';
		if( start != i - 1 ) {
			*tmp++ = '-';
			*tmp++ = 'a';
			*tmp++ = i - 1 + '0';
		}
		*tmp = '\0';
		already = TRUE;
		flag = FALSE;
		}
	}
	}
}


/*

  C~fBGCgf[^̃Zbg

  */
private void	setIMD( code , op , ptr , size )
disasm	*code;
operand *op;
address ptr;
opesize size;
{
	char	*optr = op->operand;
	int 	byte4 = (int)BYTE4;

	op->ea = IMMED;
	op->eaadrs = PC + code->bytes;

	switch( size ) {
	case BYTESIZE:
		code->bytes += 2;
		IfNeedStr {
			*optr++ = '#';
			if( BYTE3 == 0xff && SignBYTE4 < 0 ) {
				*optr++ = '-';
				byte4 = -byte4 & 0xff;
			}
			itox2d( optr , byte4 );
		}
		if( BYTE3 != 0 && ( BYTE3 != 0xff || SignBYTE4 >= 0 ) && Disasm_Exact )
			UNDEFINED;
		op->opval = (address)BYTE4;
		break;
	case WORDSIZE:
		code->bytes += 2;
		op->opval = (address)WORD2;
		IfNeedStr {
			*optr++ = '#';
			itox4d( optr , (LONG)op->opval );
		}
		break;
	case LONGSIZE:
		code->bytes += 4;
		op->opval = *(address*)( ptr + 2 );
		IfNeedStr {
			*optr++ = '#';
			itox8d( optr , (LONG)op->opval );
		}
		break;
	default:	/* reduce warning message */
		;
	}
}


private void	setAnDisp( code , op , regno , disp )
disasm	*code;
operand *op;
int 	regno;
int 	disp;
{
	char	*optr = op->operand;
	WORD	d16 = (WORD)disp;

#ifdef	OSKDIS
    ULONG	a6disp = (ULONG)disp;

	if (regno == 6) {
		lblbuf	*lptr;
		lblmode	wkmode;

		switch (HeadOSK.type & 0x0F00) {
			case 0x0100:	/* Program */
			case 0x0b00:	/* Trap */
				a6disp += 0x8000;			/* A6 ̃ItZbg𒲐	*/
				d16 = disp + 0x8000;		/* A6 ̃ItZbg𒲐	*/
/*				regist_label(BeginBSS + a6disp, DATLABEL | UNKNOWN);	*/
				if ((lptr = search_label(BeginBSS + a6disp)) != NULL) {
					wkmode = (lptr->mode & (CODEPTR | DATAPTR));
				}
				else {
					wkmode = DATLABEL;
				}
				regist_label(BeginBSS + a6disp, wkmode | code->size2 | FORCE);
				op->eaadrs = PC + code->bytes;
				op->ea = AregDISP;
				code->bytes += 2;
				IfNeedStr {
					*optr++ = 'L';	/* x蔲		*/
					*optr++ = '0';	/* L00xxxx ȃx	*/
					*optr++ = '0';	/* l͂Vsœo^		*/
					optr = itox4( optr , BeginBSS + d16 );
					strcpy( optr , "(an)" );
					*( optr + 2 ) = regno + '0';
				}
				return;
			default:
				break;
		}
	}
#endif	/* OSKDIS	*/

	op->eaadrs = PC + code->bytes;
	op->ea = AregDISP;
	code->bytes += 2;
	IfNeedStr {
		if( d16 < 0 ) {
			*optr++ = '-';
			d16 = -d16 & 0xffff;
		}
		optr = itox4d( optr , d16 );
		if( !d16 ){
			strcpy( optr, ".w" );
			optr+=2;
		}
		strcpy( optr , "(an)" );
		*( optr + 2 ) = regno + '0';
	}
}


/*

  ߂̎AhXǂAΉ镶Ԃ
  code->bytes , code->size ZbgĂĂяo
  ptr ɃIyR[h̃AhX

  */
#define ODDCHECK	if( Disasm_AddressErrorUndefined && (long)op->opval & 1 &&\
				code->size2 != BYTESIZE && code->size2 != UNKNOWN ) {\
				UNDEFINED;\
				return;\
			}
private void	setEA( code , op , ptr , mode )
disasm	*code;
operand *op;
address ptr;
int mode;
{
	int				eamode , eareg;		/* AhX[hAAhXWX^ */
	int				undefbyte;
	LONG			temp;
	unsigned char	scale,indirect=0,zreg=0,zareg;
	unsigned char	bdsize=0,odsize=0;
	signed int		lim,bd=0,od=0;
	signed short	d16;
	signed char 	d8;
	char			*optr = (char*)op->operand;

	if( mode & MOVEOPT ) {			/* move ߂̑QIyh̏ꍇ */
		eamode = ( WORD1 >> 6 ) & 7;
		eareg  = ( BYTE1 >> 1 ) & 7;
	} else {
		eamode = ( WORD1 >> 3 ) & 7;
		eareg = WORD1 & 7;
	}

	if( eamode == 7 ){
		if( (( mode >> 8 ) & pow2[ eareg ] ) == 0 &&
		( !( mode & SRCCR ) || ( mode & SRCCR ) && eareg != 4 ) ) {
			UNDEFINED;
			return;
		}
		op->eaadrs = PC + code->bytes;
		op->ea = 8 + eareg;
		switch( eareg ) {
			case 0: 				/* abs.w AbShort */
				op->opval = (address)*(UWORD *)( ptr + code->bytes );
				ODDCHECK;
				IfNeedStr {
					itox4d( optr , (LONG)op->opval );
					strcat( optr , ".w" );
				}
				code->bytes += 2;
				return;
			case 1: 				/* abs.l AbLong */
				op->opval = *(address *)( ptr + code->bytes );
				ODDCHECK;
				IfNeedStr {
					itox8d( optr , (LONG)op->opval );
					if( 0x00008000 > (unsigned long)op->opval ||
					(LONG)op->opval >= 0xFFFF8000 )
						strcat( optr , ".l" );
				}
				code->bytes += 4;
				return;
			case 2: 				/* d16(pc) */
				op->labelchange1 = TRUE;
				d16 = *(WORD*)( ptr + code->bytes );
				op->opval = PC + code->bytes + d16;
				ODDCHECK;
				IfNeedStr {
					if( d16 < 0 ) {
						*optr++ = '-';
						d16 = -d16 & 0xffff;
					}
					itox4d( optr , d16 );
					strcat( optr , "(pc)" );
				}
				code->bytes += 2;
				return;
			case 3: 				/* d8(pc,ix) */
				op->labelchange1 = TRUE;
				temp = *(UWORD*)( ptr + code->bytes );		/* temp = g[h */
				if( temp & 0x0100 ) {
/* ttH[}bg̊g[h */
					if( temp & 0x08 || MPU_type < 20 ){
						UNDEFINED;
						return;
					}

					switch( (temp>>4) & 0x03 ){
						case 0:
								UNDEFINED;
								return;
						case 1:
								bdsize = 0;
								break;
						case 2:
								bdsize = 2;
								bd = *(signed short*)( ptr + code->bytes + 2 );
								op->eaadrs = PC + code->bytes + 2;
								break;
						case 3:
								bdsize = 4;
								bd = *(signed long*)(  ptr + code->bytes + 2 );
								op->eaadrs = PC + code->bytes + 2;
								break;
					}


					switch( ((temp & 0x40)>>3) | (temp & 7) ){
						case 0x0:
							op->ea = PCIDXB;
							indirect = 0;
							zreg = FALSE;
							odsize = 0;
							break;
						case 0x1:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = FALSE;
							odsize = 0;
							break;
						case 0x2:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = FALSE;
							odsize = 2;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
							break;
						case 0x3:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = FALSE;
							odsize = 4;
							op->labelchange2 = TRUE;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
							break;
						case 0x4:
							UNDEFINED;
							return;
						case 0x5:
							op->ea = PCPOSTIDX;
							indirect = 1;
							zreg = FALSE;
							odsize = 0;
							break;
						case 0x6:
							op->ea = PCPOSTIDX;
							indirect = 1;
							zreg = FALSE;
							odsize = 2;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
							break;
						case 0x7:
							op->ea = PCPOSTIDX;
						indirect = 1;
							zreg = FALSE;
							odsize = 4;
							op->labelchange2 = TRUE;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
							break;
						case 0x8:
							op->ea = PCIDXB;
							indirect = 0;
							zreg = TRUE;
							odsize = 0;
							break;
						case 0x9:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = TRUE;
							odsize = 0;
							break;
						case 0xa:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = TRUE;
							odsize = 2;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
							break;
						case 0xb:
							op->ea = PCPREIDX;
							indirect = 2;
							zreg = TRUE;
							odsize = 4;
							op->labelchange2 = TRUE;
							op->eaadrs2 = PC + code->bytes + 2 + bdsize;
							od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
							break;
						case 0xc:
						case 0xd:
						case 0xe:
						case 0xf:
							UNDEFINED;
							return;
					}

					if( (UndefRegLevel & 2) && zreg && (temp & 0x7000) ){
						UNDEFINED;		/* TvXꂽWX^No  0 Ȃ */
						return;
					}

					if( (UndefRegLevel & 4) && zreg && (temp & 0x0600) ){
						UNDEFINED;		/* TvXꂽWX^XP[OĂ */
						return;
					}

					if( (UndefRegLevel & 8) && zreg && (temp & 0x0800) ){
						UNDEFINED;		/* TvXꂽWX^ .l w肳Ă */
						return;
					}


					zareg = (temp & 0x80);

					if( bdsize ){
						op->opval = zareg ? (address)bd : PC + bd + code->bytes;
					}

					if( odsize == 4 )	op->opval2  = (address)od;

					op->exbd = bdsize;
					op->exod = odsize;

					IfNeedStr {
						*optr++ = '(';
						if( indirect )
							*optr++ = '[';

						if( bdsize ){
							lim = ((bdsize == 2) ? 127 : 32767);
							if(bd < 0){
								*optr++ = '-';
								bd = -bd;
								lim += 1;
							}

							if( bdsize == 2 ){
								bd &= 0xffff;
								optr = itox4d( optr , bd );
								if(bd>lim || indirect )
									*optr++ = ',';
								else{
									strcpy( optr , ".w," );
									optr += 3;
								}

							}else if(bdsize == 4){
								optr = itox8d( optr , bd );
								if(bd>lim)
									*optr++ = ',';
								else{
									strcpy( optr , ".l," );
									optr += 3;
								}
							}
						}

						if( zareg ){
							*optr++ = 'z';
							op->bsflag = TRUE;
						}else
							op->bsflag = FALSE;

						strcpy( optr , "pc" );
						optr += 2;
						if( indirect == 1 )
							*optr++ = ']';

						if( !(((UndefRegLevel & 0x0e) == 0x0e) && zreg)){
							*optr++ = ',';
							if( zreg )
								*optr++ = 'z';

							if( sp_a7_flag && ((temp>>12) == 15) ){
								*optr++ = 's';
								*optr++ = 'p';
							}else{
								*optr++ = ( temp & 0x8000 ? 'a' : 'd' );
								*optr++ = ( ( temp >> 12 ) & 7 ) + '0';
							}
							*optr++ = '.';
							*optr++ = ( temp & 0x0800 ? 'l' : 'w' );


							if(scale = (temp>>9) & 0x03){
								*optr++ = '*';
								switch( scale ){
									case 0x1:	*optr++ = '2';	break;
									case 0x2:	*optr++ = '4';	break;
									case 0x3:	*optr++ = '8';	break;
								}
							}
						}


						if( indirect == 2 )
							*optr++ = ']';

						if( odsize ){
							*optr++ = ',';
							lim = 32767;
							if(od < 0){
								*optr++ = '-';
								od = -od;
								lim += 1;
							}

							if( odsize == 2 ){
								od &= 0xffff;
								optr = itox4d( optr , od );
							}else if(odsize == 4){
								optr = itox8d( optr , od );
								if(od<=lim){
									strcpy( optr , ".l" );
									optr += 2;
								}
							}
						}

						*optr++ = ')';
						*optr++ = '\0';
					}

					code->bytes += ( 2 + bdsize + odsize );
					return;
				}else{
/* ZktH[}bg̊g[h */
					d8 = *(signed char*)( ptr + code->bytes + 1 );
					temp = *(UBYTE*)( ptr + code->bytes );			/* temp = g[h */
					op->opval = PC + d8 + code->bytes;

/* scaling check (68020̃`FbN) */
					if( (scale = (temp>>1) & 0x03) && (MPU_type < 20) ){
						UNDEFINED;
						return;
					}

					IfNeedStr {
						if( d8 < 0 ) {
							*optr++ = '-';
							d8 = -d8 & 0xff;
						}
						optr = itox2d( optr , d8 );
						strcpy( optr , "(pc," );
						optr += 4;
						*optr++ = ( temp & 0x80 ? 'a' : 'd' );
						*optr++ = ( ( temp >> 4 ) & 7 ) + '0';
						*optr++ = '.';
						*optr++ = ( temp & 0x08 ? 'l' : 'w' );

/* scaling (68020̃`FbN) */
						if(scale = (temp>>1) & 0x03){
							*optr++ = '*';
							switch( scale ){
								case 0x1:	*optr++ = '2';	break;
								case 0x2:	*optr++ = '4';	break;
								case 0x3:	*optr++ = '8';	break;
							}
						}
						*optr++ = ')';
						*optr	= '\0';
					}
					code->bytes += 2;
					return;
				}
			case 4:
				if( mode & SRCCR ) {
					op->eaadrs = (address)-1;
					op->ea = SRCCR;
					switch( code->size ) {
						case BYTESIZE:
							IfNeedStr { strcpy( op->operand , "ccr" ); }
							break;
						case WORDSIZE:
							IfNeedStr { strcpy( op->operand , "sr" ); }
							break;
						default:
							UNDEFINED;
							break;
					}
					return;
				}else{
					switch( code->size ){		/* #Imm */
						case BYTESIZE:
							op->opval = (address)*(UBYTE*)( ptr + code->bytes + 1 );
							undefbyte = *(UBYTE*)( ptr + code->bytes );
							IfNeedStr {
								temp = (LONG)op->opval;
								*optr++ = '#';
								if( undefbyte == 0xff && (signed char)( op->opval ) < 0 ) {
									*optr++ = '-';
									temp = -(UBYTE)temp & 0xff;
								}
								itox2d( optr , temp );
							}
							if( Disasm_Exact && undefbyte != 0 &&
							( undefbyte != 0xff || (signed char)(op->opval) >= 0 ) )
								UNDEFINED;
							code->bytes += 2;
							return;
						case WORDSIZE:
							op->opval = (address)*(UWORD*)( ptr + code->bytes );
							IfNeedStr {
								*optr++ = '#';
								itox4d( optr , (LONG)op->opval );
							}
							code->bytes += 2;
							return;
						case LONGSIZE:
							op->opval = *(address*)( ptr + code->bytes );
							IfNeedStr {
								*optr++ = '#';
								itox8d( optr , (LONG)op->opval );
							}
							code->bytes += 4;
							return;
						case QUADSIZE:
							IfNeedStr {
								*optr++ = '#';
								*optr++ = '$';
								itox8( optr    , *(long*)( ptr + code->bytes    ) );
								itox8( optr+8  , *(long*)( ptr + code->bytes + 4) );
							}
							code->bytes += 8;
							return;
						case SINGLESIZE:
							op->labelchange1 = TRUE;	/* ȂƂz邩? ^^ */
							op->opval = *(address*)( ptr + code->bytes );
							IfNeedStr {
								*optr++ = '#';
								sprintf( optr, "%.30g", *(float*)( ptr + code->bytes ) );
							}
							code->bytes += 4;
							return;
						case EXTENDSIZE:
							IfNeedStr {
								*optr++ = '#';
								*optr++ = '!';
								itox8( optr    , *(long*)( ptr + code->bytes    ) );
								itox8( optr+8  , *(long*)( ptr + code->bytes + 4) );
								itox8( optr+16 , *(long*)( ptr + code->bytes + 8) );
							}
							code->bytes += 12;
							return;
						case PACKEDSIZE:
							IfNeedStr {
								*optr++ = '#';
								*optr++ = '!';
								itox8( optr    , *(long*)( ptr + code->bytes    ) );
								itox8( optr+8  , *(long*)( ptr + code->bytes + 4) );
								itox8( optr+16 , *(long*)( ptr + code->bytes + 8) );
							}
							code->bytes += 12;
							return;
						case DOUBLESIZE:
							IfNeedStr {
								*optr++ = '#';
								sprintf( optr, "%.30g", *(double*)( ptr + code->bytes ) );
							}
							code->bytes += 8;
							return;
						default:	/* reduce warning message */
							;
					}
				}
		}
	}else{			/* if( eamode != 7 ) */
		if( ( mode & pow2[ eamode ] ) == 0 ) {
			UNDEFINED;
			return;
		}
		op->eaadrs = (address)-1;
		op->ea = eamode;

		if( eamode <= 4 && !Disasm_String )
			return;

		switch( eamode ){
		case 0:
			setDn( op , eareg );				/* Dn */
			return;
		case 1:
			setAn( op , eareg );				/* An */
			return;
		case 2:
			IfNeedStr {
			strcpy( op->operand , "(an)" ); 		/* (An) */
			op->operand[2] = eareg + '0';
			}
			return;
		case 3:
			IfNeedStr {
			strcpy( op->operand , "(an)+" );		/* (An)+ */
			op->operand[2] = eareg + '0';
			}
			return;
		case 4:
			IfNeedStr {
			strcpy( op->operand , "-(an)" );		/* -(An) */
			op->operand[3] = eareg + '0';
			}
			return;
		case 5: 						/* d16(An) */
			setAnDisp( code , op , eareg , *(WORD*)( ptr + code->bytes ) );
			return;
		case 6:

			temp = *(UWORD*)( ptr + code->bytes );		/* temp = g[h */
			if( *(UBYTE*)( ptr + code->bytes ) & 1 ) {
/* ttH[}bg̊g[h */

				if( temp & 0x08 || MPU_type < 20 ){
					UNDEFINED;
					return;
				}

				switch( (temp>>4) & 0x03 ){
					case 0:
						UNDEFINED;
						return;
					case 1:
						bdsize = 0;
						break;
					case 2:
						bdsize = 2;
						bd = *(signed short*)( ptr + code->bytes + 2 );
						op->eaadrs = PC + code->bytes + 2;
						break;
					case 3:
						bdsize = 4;
						op->labelchange1 = TRUE;
						bd = *(signed long*)(  ptr + code->bytes + 2 );
						op->eaadrs = PC + code->bytes + 2;
						break;
				}


				switch( ((temp & 0x40)>>3) | (temp & 7) ){
					case 0x0:
						op->ea = AregIDXB;
						indirect = 0;
						zreg = FALSE;
						odsize = 0;
						break;
					case 0x1:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = FALSE;
						odsize = 0;
						break;
					case 0x2:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = FALSE;
						odsize = 2;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
						break;
					case 0x3:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = FALSE;
						odsize = 4;
						op->labelchange2 = TRUE;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
						break;
					case 0x4:
						UNDEFINED;
						return;
					case 0x5:
						op->ea = AregPOSTIDX;
						indirect = 1;
						zreg = FALSE;
						odsize = 0;
						break;
					case 0x6:
						op->ea = AregPOSTIDX;
						indirect = 1;
						zreg = FALSE;
						odsize = 2;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
						break;
					case 0x7:
						op->ea = AregPOSTIDX;
						indirect = 1;
						zreg = FALSE;
						odsize = 4;
						op->labelchange2 = TRUE;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
						break;
					case 0x8:
						op->ea = AregIDXB;
						indirect = 0;
						zreg = TRUE;
						odsize = 0;
						break;
					case 0x9:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = TRUE;
						odsize = 0;
						break;
					case 0xa:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = TRUE;
						odsize = 2;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed short*)( ptr + code->bytes + 2 + bdsize );
						break;
					case 0xb:
						op->ea = AregPREIDX;
						indirect = 2;
						zreg = TRUE;
						odsize = 4;
						op->labelchange2 = TRUE;
						op->eaadrs2 = PC + code->bytes + 2 + bdsize;
						od = *(signed long*)(  ptr + code->bytes + 2 + bdsize );
						break;
					case 0xc:
					case 0xd:
					case 0xe:
					case 0xf:
						UNDEFINED;
						return;
				}

				if( (UndefRegLevel & 2) && zreg && (temp & 0x7000) ){
					UNDEFINED;		/* TvXꂽWX^No  0 Ȃ */
					return;
				}

				if( (UndefRegLevel & 4) && zreg && (temp & 0x0600) ){
					UNDEFINED;		/* TvXꂽWX^XP[OĂ */
					return;
				}

				if( (UndefRegLevel & 8) && zreg && (temp & 0x0800) ){
					UNDEFINED;		/* TvXꂽWX^ .l w肳Ă */
					return;
				}

				zareg = (temp & 0x80);

				if( (UndefRegLevel & 2) && zareg && eareg ){
					UNDEFINED;
					return;
				}


				if( bdsize == 4 )	op->opval   = (address)bd;
				if( odsize == 4 )	op->opval2  = (address)od;

				op->exbd = bdsize;
				op->exod = odsize;

				IfNeedStr {
					*optr++ = '(';
					if( indirect )
						*optr++ = '[';

					if( bdsize ){
						lim = ((bdsize == 2) ? 127 : 32767);
						if(bd < 0){
							*optr++ = '-';
							bd = -bd;
							lim += 1;
						}

						if( bdsize == 2 ){
							bd &= 0xffff;
							optr = itox4d( optr , bd );
/*							if(bd>lim)	*/
							if(bd>lim || indirect )
								*optr++ = ',';
							else{
								strcpy( optr , ".w," );
								optr += 3;
							}

						}else if(bdsize == 4){
							optr = itox8d( optr , bd );
							if(bd>lim)
								*optr++ = ',';
							else{
								strcpy( optr , ".l," );
								optr += 3;
							}
						}
					}

					if( zareg )
						*optr++ = 'z';

					if( sp_a7_flag && eareg == 7 ){
						*optr++ = 's';
						*optr++ = 'p';
					}else{
						*optr++ = 'a';
						*optr++ = eareg + '0';
					}

					if( indirect == 1 )
						*optr++ = ']';

					if( !(((UndefRegLevel & 0x0e) == 0x0e) && zreg)){
						*optr++ = ',';
						if( zreg )
							*optr++ = 'z';

						if( sp_a7_flag && ((temp>>12) == 15) ){
							*optr++ = 's';
							*optr++ = 'p';
						}else{
							*optr++ = ( temp & 0x8000 ? 'a' : 'd' );
							*optr++ = ( ( temp >> 12 ) & 7 ) + '0';
						}

						*optr++ = '.';
						*optr++ = ( temp & 0x0800 ? 'l' : 'w' );

						if(scale = (temp>>9) & 0x03){
							*optr++ = '*';
							switch( scale ){
								case 0x1:	*optr++ = '2';	break;
								case 0x2:	*optr++ = '4';	break;
								case 0x3:	*optr++ = '8';	break;
							}
						}
					}

					if( indirect == 2 )
						*optr++ = ']';

					if( odsize ){
						*optr++ = ',';
						lim = 32767;
						if(od < 0){
							*optr++ = '-';
							od = -od;
							lim += 1;
						}

						if( odsize == 2 ){
							od &= 0xffff;
							optr = itox4d( optr , od );
						}else if(odsize == 4){
							optr = itox8d( optr , od );
							if(bd<lim){
								strcpy( optr , ".l" );
								optr += 2;
							}
						}
					}

					*optr++ = ')';
					*optr++ = '\0';
				}

				code->bytes += ( 2 + bdsize + odsize );
				return;

			}else{

				op->eaadrs = PC + code->bytes;			/* d8(An,ix) */

/* ZktH[}bg̊g[h */
				d8 = *(signed char*)( ptr + code->bytes + 1 );
				temp = *(UBYTE*)( ptr + code->bytes );

/* scaling check (68020̃`FbN) */
				if( (scale = (temp>>1) & 0x03) && (MPU_type < 20) ){
					UNDEFINED;
					return;
				}

				IfNeedStr {
					if( d8 < 0 ) {
						*optr++ = '-';
						d8 = -d8 & 0xff;
					}
					optr = itox2d( optr , d8 );
					strcpy( optr , "(a" );
					optr += 2;
					*optr++ = eareg + '0';
					*optr++ = ',';
					*optr++ = ( temp & 0x80 ? 'a' : 'd' );
					*optr++ = ( ( temp >> 4 ) & 7 ) + '0';
					*optr++ = '.';
					*optr++ = ( temp & 0x08 ? 'l' : 'w' );

/* scaling (68020̃`FbN) */
					if(scale = (temp>>1) & 0x03){
						*optr++ = '*';
						switch( scale ){
							case 0x1:	*optr++ = '2';	break;
							case 0x2:	*optr++ = '4';	break;
							case 0x3:	*optr++ = '8';	break;
						}
					}
					*optr++ = ')';
					*optr	= '\0';
				}
				code->bytes += 2;
				return;
			}
		}
	}
}

