/* $Id: etc.c,v 1.1 1996/11/07 08:03:32 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	Gp[`
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include <stdio.h>
#include <ctype.h>	/* isxdigit isdigit */
#include <stdlib.h>	/* exit */
#include "estruct.h"
#include "global.h"
#include "etc.h"
#include "label.h"
#include "offset.h"
#include "symbol.h"

USEOPTION	option_q;

/* function in main.c */
extern void free_load_buffer( void );


extern ULONG	atox( p )
char	*p;
{
    ULONG	val = 0;
    
    while( isxdigit( *p )) {
	if( isdigit( *p ) )
	    val = val * 16 + *p - '0';
	else
	    val = val * 16 + tolower( *p ) - 'a' + 10 ;
	p++;
    }
    return val;
}


#ifndef	__GNUC__
extern ULONG	min( a , b )
ULONG	a , b;
{
    return a < b ? a : b;
}


extern ULONG	max( a , b );
ULONG	a , b;
{
    return a > b ? a : b;
}
#endif


extern void	err( code , fmtstr , args )
int	code;
char	*fmtstr;
int	args;
{
    int		*arg;
    
    arg = &args;
    fprintf( stderr , fmtstr , arg[0],arg[1],arg[2],arg[3],arg[4] );
    if( code ) {
	free_labelbuf();
	free_relocate_buffer();
	free_symbuf();
	free_load_buffer();
	exit( code );
    }
}


/*

  safe malloc

*/
extern void *Malloc( byte )
ULONG	byte;
{
    void	*rc;

    if( byte == 0 )
	byte = 1;
    if( ( rc = malloc( byte ) ) == NULL ) {
	err( 1 , "q[vsĂ܂\n" );
    }
    return rc;
}


/*

  mfree

*/
extern void	Mfree( ptr )
void	*ptr;
{
    if( ptr != NULL )
	free( ptr );
}


/*

  safe realloc

*/
extern void	*Realloc( ptr , size )
void	*ptr;
int	size;
{
    void	*rc;
    
    if( ( rc = realloc( ptr , size ) ) == NULL )
	err( 1 , "q[vsĂ܂\n" );
    return rc ;
}
