/* $Id: include.c,v 1.1 1996/11/07 08:03:42 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	CN[ht@Cǂݍ݃W[
 *	Copyright (C) 1989,1990 K.Abe, 1994 R.ShimiZu
 *	All rights reserved.
 *
 */

#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>	/* getenv */
#ifdef unix
	#include <unistd.h>
#endif
#include	"estruct.h"
#include	"global.h"
#include	"include.h"
#include	"disasm.h"	/* OSlabel , FElabel , SXlabel */
#include	"generate.h"	/* IOCSlabel */
#include	"etc.h"

#ifdef	OSKDIS
char	OS9_mac_path[MAX_INCLUDE_FILE_PATH];
char	MATH_mac_path[MAX_INCLUDE_FILE_PATH];
char	CIO_mac_path[MAX_INCLUDE_FILE_PATH];
#else
char	Doscall_mac_path[MAX_INCLUDE_FILE_PATH];
char	Iocscall_mac_path[MAX_INCLUDE_FILE_PATH];
char	Fefunc_h_path[MAX_INCLUDE_FILE_PATH];
char	*Sxcall_mac_path;
#endif	/* OSKDIS	*/

/* static ֐vg^Cv */
private int	readfile( char* , char** , int , char* );
private int	getlabel( char* , char** , int , char* );
extern void	*strndup( char *string , int length );

/*

  doscall.mac iocscall.mac fefunc.h ϐ include ɂēǂݍ

*/
extern void	load_OS_sym()
{
    char	*inc , *dis_inc;
    char	*sx_mac;			/* SX window macro-def file(full path) */
    int		i;

#ifdef	OSKDIS
    for( i = 0 ; i < 256 ; i++ ) {		/* initialize */
		OS9label[i] = MATHlabel[i] = CIOlabel[i] = NULL;
    }

	if ((dis_inc = getenv( "DISDEFS" )) == NULL) {
/*		err(1, "ϐ DISDEFS ݒ肳Ă܂\n");	*/
		fprintf(stderr, "ϐ DISDEFS ݒ肳Ă܂\n");
	}
	else {
		if ( readfile(strcat(strcpy(OS9_mac_path, dis_inc), "/os9defs.d"),
			OS9label, 0, "OS9") ) {
/*			err(1, "os9defs.d I[vo܂\n");	*/
			fprintf(stderr, "os9defs.d I[vo܂\n");
		}

		if ( readfile(strcat(strcpy(MATH_mac_path, dis_inc), "/mathdefs.d"),
			MATHlabel, 0, "T$Math") ) {
/*			err(1, "mathdefs.d I[vo܂\n");	*/
			fprintf(stderr, "mathdefs.d I[vo܂\n");
		}

		if ( readfile(strcat(strcpy(CIO_mac_path, dis_inc), "/ciodefs.d"),
			CIOlabel, 0, "CIO$Trap") ) {
/*			err(1, "ciodefs.d I[vo܂\n");	*/
			fprintf(stderr, "ciodefs.d I[vo܂\n");
		}
	}
#else
    for( i = 0 ; i < 256 ; i++ ) {		/* initialize */
	OSlabel[i] = FElabel[i] = IOCSlabel[i] = NULL;
    }

    for( i = 0 ; i < SXCALL_MAX ; i++ )
	SXlabel[i] = NULL;

    dis_inc = getenv( "dis_include" );
    inc = getenv( "include" );
    Sxcall_mac_path = sx_mac = getenv( "dis_sxmac" );

    if( dis_inc == NULL && inc == NULL )
	err( 1 , "ϐ (dis_)include ݒ肳Ă܂\n" );

    if( ( dis_inc == NULL ||
	  readfile( strcat( strcpy( Doscall_mac_path , dis_inc ) , "/doscall.mac" ) ,
		   OSlabel , 0xff , OSCallName ) ) &&
	(     inc == NULL ||
	 readfile( strcat( strcpy( Doscall_mac_path ,     inc ) , "/doscall.mac" ) ,
		  OSlabel , 0xff , OSCallName ) ) )
	err( 1 , "doscall.mac I[vo܂\n" );

    if( ( dis_inc == NULL ||
	  readfile( strcat( strcpy( Iocscall_mac_path , dis_inc ) , "/iocscall.mac" ) ,
		   IOCSlabel , 0 , IOCSCallName ) ) &&
	(     inc == NULL ||
	 readfile( strcat( strcpy( Iocscall_mac_path ,     inc ) , "/iocscall.mac" ) ,
		  IOCSlabel , 0 , IOCSCallName ) ) )
	err( 1 , "iocscall.mac I[vo܂\n" );

    if( ( dis_inc == NULL ||
	  readfile( strcat( strcpy( Fefunc_h_path , dis_inc ) , "/fefunc.dis" ) ,
		   FElabel , 0xfe , FECallName ) &&
	  readfile( strcat( strcpy( Fefunc_h_path , dis_inc ), "/fefunc.h"   ) ,
		   FElabel , 0xfe , FECallName ) ) &&
	(     inc == NULL ||
	 readfile( strcat( strcpy( Fefunc_h_path ,     inc ) , "/fefunc.dis" ) ,
		  FElabel , 0xfe , FECallName ) &&
	 readfile( strcat( strcpy( Fefunc_h_path ,     inc ) , "/fefunc.h"   ) ,
		  FElabel , 0xfe , FECallName ) ) )
	err( 1 , "fefunc.dis , fefunc.h I[vo܂\n" );

    if( Sxcall_mac_path != NULL )
	if( readfile( Sxcall_mac_path , SXlabel, 0xa , SXCallName ) )
	    err( 1 , "%s I[vo܂\n" , Sxcall_mac_path );
#endif	/* OSKDIS	*/
}


private int	readfile( filename , label , hbyte , callname )
char	*filename;
char	*label[];
int	hbyte;
char	*callname;
{
    char	linebuf[128];
    FILE	*fp;
    int		label_num = 0;

    if( ( fp = fopen( filename , "r" )) == NULL )
    return 1;

    fprintf( stderr , "Reading %s...\n" , filename );
    while( 1 ) {
	if( ( fgets( linebuf , 128 , fp )) == NULL )
	    break;
	label_num += getlabel( linebuf , label , hbyte , callname );
    }
    fclose( fp );
    if( label_num == 0 )
	err( 1 , "Error : %s ɂ̓V{P`Ă܂\n" );
    return 0;
}


/*

  AZûdpt^߂̍sǂݎ
  
*/
#define	skipspace\
{ while( ( *ptr == ' ' || *ptr == '\t' ) && *ptr != 0 ) ptr++;}
#define	untilspace\
{ while( *ptr != ' ' && *ptr != '\t' && *ptr != 0 ) ptr++; }

private int	getlabel( linebuf , label , hbyte , callname )
char	*linebuf;
char	*label[];
int	hbyte;
char	*callname;
{
    char	*ptr;
    int		labellen , val;
    char	*callnameend;
    int		rc = 0;
    int		strncmpi( char* , char* , int );

    if( strstr( linebuf , "macro" ) != NULL ) {
	if( ( callnameend = strpbrk( linebuf , " \t" ) ) == NULL )
	    err( 1 , "call macro ǂݎ܂\n" );
	strncpy( callname , linebuf , callnameend - linebuf );
	callname[ callnameend - linebuf ] = '\0';
    }
    if( *linebuf != '\n' && *linebuf != '*' && *linebuf != '\t' ) {
	ptr = linebuf;
	untilspace;
	labellen = ptr - linebuf;
	skipspace;
	if( *ptr == '.' ) ptr++;
	if( strncmpi( ptr , "equ" , 3 ) == 0 ){
	    ptr += 3;
	    skipspace;
	    if( *ptr == '$' ) {
		ptr++;
		val = atox( ptr );
		rc = 1;
		if( hbyte != 0xa ) {
		    if( ( val >> 8 ) == hbyte )
				if( ! label[ val & 0xff ] )
					label[ val & 0xff ] = strndup( linebuf , labellen );
		} else {
		    if( ( val >> 12 ) == 0xa && val < 0xa000 + SXCALL_MAX )
				if( ! label[ val & 0xfff ] )
					label[ val & 0xfff ] = strndup( linebuf , labellen );
		}
	    }
	}
    }
    return rc;
}


extern void *
strndup( char *string , int length )
{
    int	len = min( strlen( string ) , length ) + 1;
    char *rc = Malloc( len );
/*    strncpy( rc , string , length );*/
    strncpy( rc , string , len );
/*    rc[ length ] = '\0';*/
    rc[ len - 1 ] = '\0';
    return rc;
}
