/* $Id: label.c,v 1.1 1996/11/07 08:03:44 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	xǗW[
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "estruct.h"
#include "global.h"
#include "etc.h"
#include "label.h"

#define AVL_USERDATA	lblbuf
#define AVL_INCLUDE
#include "../avl/avl.h"

#define	AVL_COMPARE(label1,label2)\
    (signed)((unsigned)(label1)->label - (unsigned)(label2)->label)

#include "../avl/avl.c"

/* static ֐vg^Cv */
private avl_node	*search_label2(address adrs);


/*#define	DEBUG*/

static avl_root_node	*LabelRoot;
static lblbuf	Nomore = {
    (address)0xffffffff , NULL , DATLABEL | UNKNOWN , 0 , 1
};


private int	compare( label1 , label2 )
lblbuf	*label1 , *label2;
{
    return (unsigned long)label1->label - (unsigned long)label2->label;
}


private void	print( label )
lblbuf	*label;
{
    printf( "%x" , label->label );
}


/*

  xobt@

*/
extern void	init_labelbuf()
{
    LabelRoot = AVL_create_tree( compare , free , print );
}


/*

  n

*/
extern void	free_labelbuf()
{
    ;
}


/*

  adrs  mode ^̃GgAhXƂēo^
  ɓo^Ăio^ĂAhX̌^ oldmode Ƃj
	modevO && oldmodevO	FALSE
	modevO && oldmodef[^		o^ TRUE
	modef[^     && oldmodevO	FALSE
	modef[^     && oldmodef[^
	mode == KNOWN && oldmode == UNKNOWN		o^
	oldmode != mode					o^
	mode == UNKNOWN && oldmode == KNOWN		ȂɂȂFALSE Ԃ
	Ԃl adrs ͂Kv邩\( vȌꍇ )

*/
/*#define	DEBUG*/
extern boolean	regist_label( adrs , mode )
address	adrs;
lblmode	mode;
{
    lblbuf	*lptr , *ins_buf;

    if( adrs < BeginTEXT || adrs > Last )
	return FALSE;

    if( isPROLABEL( mode ) ) {
	if( (long)adrs & 1 )
	    return FALSE;
	else if( adrs > Available_text_end ) {
	    regist_label( adrs , DATLABEL | UNKNOWN );
	    return FALSE;
	}
    }

    if( Debug & BLABEL )
	printf( "Regist %05x as %x\n" , adrs , mode );

    if( ( lptr = search_label( adrs ) ) != NULL ) {
	lptr->count++;
	if( mode & ( TABLE | ENDTABLE ) ) {
	    lptr->mode = lptr->mode & ( TABLE | ENDTABLE ) | mode;
	    if( Debug & BLABEL )
		printf( "registed(table) %x\n" , lptr->mode );
	    return FALSE;
	}
	if( ( lptr->mode & FORCE ) && !( isDATLABEL( lptr->mode ) && isDATLABEL( mode ) ) ) {
	    if( Debug & BLABEL )
		printf( "but denied\n" );
	    return FALSE;
	}
	if( mode & FORCE ) {
	    lptr->mode = lptr->mode & ( TABLE | ENDTABLE ) | mode;
	    if( Debug & BLABEL )
		printf( "regist : %x(%d) was forced to %x\n", adrs, lptr->count, lptr->mode );
	    return TRUE;
	}
	if( isPROLABEL( mode ) ) {
	    if( isPROLABEL( lptr->mode ) )
		return TRUE;
	    else {				/* if( isDATLABEL( lptr->mode ) ) */
		lptr->mode = lptr->mode & ENDTABLE | PROLABEL;
		if( Debug & BLABEL )
		    printf( "regist : %x(%d) was prog. %x\n", adrs, lptr->count, lptr->mode );
		return TRUE;
	    }
	} else {				/* if( isDATLABEL( mode ) ) */
	    if( isPROLABEL( lptr->mode ) ) {
		if( Debug & BLABEL )
		    printf( "but denied\n" );
		return FALSE;
	    } else {				/* if( isDATLABEL( lptr->mode ) ) */
		if( !(( mode & 0xff ) == UNKNOWN && ( lptr->mode & 0xff ) != UNKNOWN ) )
		    lptr->mode = ( FORCE | TABLE | ENDTABLE ) & lptr->mode | mode;
		if( Debug & BLABEL )
		    printf( "changed surely(%x)\n" , lptr->mode );
		return TRUE;
	    }
	}
    }

    ins_buf = Malloc( sizeof( lblbuf ) );
    ins_buf->label = adrs;
    ins_buf->mode = mode;
    ins_buf->shift = 0;
    ins_buf->count = 1;

    ins_buf->avl = AVL_insert( LabelRoot , ins_buf );
/*
    AVL_print_tree( LabelRoot );
    printf( "\n" );
*/
    return TRUE;
}


/*

  x̓o^

*/
extern void	unregist_label( adrs )
address	adrs;
{
    avl_node	*del;
    lblbuf	*ptr;

    if( Debug & BLABEL )
	printf( "* unregist_label %x\n" , adrs );
    if( ( del = search_label2( adrs ) ) == NULL ) {
	if( Debug & BLABEL )
	    printf( "unregist_label : %x was not registed\n" , adrs );
    } else {
	ptr = (lblbuf*)( AVL_get_data( del ) );
	if( --( ptr->count ) == 0 )
	    AVL_delete( LabelRoot , del );
    }
}
/*#undef	DEBUG*/


/*

  xobt@adrs{
  ΃obt@ɑ΂|C^
  Ȃ NULL Ԃ

*/
extern lblbuf	*search_label( adrs )
address	adrs;
{
    lblbuf	search_data;

    search_data.label = adrs;
    return AVL_get_data_safely( AVL_search( LabelRoot , &search_data ) );
}


private avl_node	*search_label2( adrs )
address	adrs;
{
    lblbuf	search_data;

    search_data.label = adrs;
    return AVL_search( LabelRoot , &search_data );
}


/*

  adrs ̎̃xobt@ւ̃|C^Ԃ
  Ԃl->label  -1 Ȃobt@GveB
  adrs Ɠx΂ꂪԂĂ̂ŒӁI

*/
extern lblbuf	*next( adrs )
address	adrs;
{
    lblbuf	search_data;
    avl_node	*node;

    if( adrs == (address)0xffffffff )
	return &Nomore;

    search_data.label = adrs;

    if( ( node = AVL_search_next( LabelRoot , &search_data ) ) == NULL )
	return &Nomore;
    else
	return AVL_get_data( node );
}


/*

  lptr ̎̃xobt@ւ̃|C^Ԃ
  Ԃl->label  -1 Ȃobt@GveB
  adrs Ɠx΂ꂪԂĂ̂ŒӁI

*/
extern lblbuf	*Next( lptr )
lblbuf	*lptr;
{
    lblbuf	*rc;

    rc = AVL_get_data_safely( AVL_next( lptr->avl ) );
    if( rc == NULL ) {
	return &Nomore;
    }
    return rc;
}


/*

  adrs  PROLABEL T
  adrs  PROLABEL Ȃ炻ꂪԂĂ

*/
extern lblbuf	*next_prolabel( adrs )
address	adrs;
{
    avl_node	*node_ptr;
    lblbuf	search_data;
#ifdef	DEBUG
    printf( "next_prolabel(%x)=",adrs );
#endif
    if( adrs == (address)0xffffffff )
	return &Nomore;

    search_data.label = adrs;
    node_ptr = AVL_search_next( LabelRoot , &search_data );
    while( node_ptr != NULL && !isPROLABEL( ((lblbuf*)AVL_get_data( node_ptr ))->mode ) )
	node_ptr = AVL_next( node_ptr );

    if( node_ptr == NULL )
	return &Nomore;
#ifdef	DEBUG
    printf( "%x\n", AVL_get_data( node_ptr ) );
#endif
    return (lblbuf*)AVL_get_data( node_ptr );
}


/*

  adrs  DATLABEL T
  adrs  DATLABEL Ȃ炻ꂪԂĂ

*/
extern lblbuf	*next_datlabel( adrs )
address	adrs;
{
    avl_node	*node_ptr;
    lblbuf	search_data;
    lblbuf	*lblptr = &Nomore;

#ifdef	DEBUG
    printf( "next_datlabel(%x)=",adrs );
#endif
    if( adrs == (address)0xffffffff )
	return &Nomore;

    search_data.label = adrs;
    node_ptr = AVL_search_next( LabelRoot , &search_data );
    while( node_ptr != NULL && ( !isDATLABEL( ( lblptr = AVL_get_data( node_ptr ))->mode ) ||
				 lblptr->shift ) )
	node_ptr = AVL_next( node_ptr );

    if( node_ptr == NULL )
	return &Nomore;
#ifdef	DEBUG
    printf( "%x(%x),%d\n",lblptr->label , lblptr->mode , lblptr->count );
#endif
    return lblptr;
}


extern int	get_Labelnum()
{
    return AVL_data_number( LabelRoot );
}
