/* $Id: labelfile.c,v 1.1 1996/11/07 08:03:48 ryo freeze $
 *
 *		\[XR[hWFl[^
 *		xt@CW[
 *		Copyright (C) 1989,1990 K.Abe
 *		All rights reserved.
 *
 */

#include		<stdio.h>
#ifndef unix
#ifdef MYU_HEADERS
		#include		<ctype.h>		/* tolower */
#else
		#include		<fctype.h>		/* ctype is bad because macro expansion */
										/* causes twice evaluation. */
#endif
#else
#include		<ctype.h>
#endif
#include		<string.h>
#include		"estruct.h"
#include		"global.h"
#include		"label.h"
#include		"analyze.h"
#include		"etc.h"
#include		"symbol.h"


/* static ֐vg^Cv */
static void 	make_header( FILE* , char* );
private int 	getline( char* , int , int , address* , char* );
private void	work( address , int , char* , int , int );


/*

  xt@Co

*/
extern void 	make_labelfile( xfilename , labelfilename )
char	*xfilename , *labelfilename;
{
	FILE		*fp;
	lblbuf		*nadrs;
	symbol		*ptr;

	if( ( fp = fopen( labelfilename , "w" ) ) == NULL ) {
		err( 0 , "%s I[vł܂łB\n" , labelfilename );
		return;
	}

	make_header( fp , xfilename );
	nadrs = next( BeginTEXT );

	while( nadrs->label != (address)-1 ) {
		fprintf( fp , "%06x\t" , nadrs->label );
		if( isPROLABEL( nadrs->mode ) )
			fputc( 'P' , fp );
		else {
			fputc( 'D' , fp );
			switch( nadrs->mode & 0xff ) {
			case STRING :
				fputc( 'S' , fp );
				break;
			case RELTABLE :
				fputc( 'R' , fp );
				break;
			case RELLONGTABLE :
				fputc( 'R' , fp );
				fputc( 'L' , fp );
				break;
			case ZTABLE :
				fputc( 'Z' , fp );
				break;
			case BYTESIZE :
				fputc( 'B' , fp );
				break;
			case WORDSIZE :
				fputc( 'W' , fp );
				break;
			case LONGSIZE :
				fputc( 'L' , fp );
				break;
			default:
				fputc( 'U' , fp );
				break;
			}
		}
		if( nadrs->mode & FORCE )
			fputc( 'F' , fp );
		if( ( ptr = symbol_search( nadrs->label ) ) != NULL )
			fprintf( fp , "\t%s" , ptr->sym );
		fputc( '\n' , fp );
/*		nadrs = next( nadrs->label + 1 );*/
		nadrs = Next( nadrs );
	}
	fclose( fp );
}


/*

  xt@C̃wb_

*/
private void	make_header( fp , filename )
FILE	*fp;
char	*filename;
{
	fputs(		  "*********************************************\n" , fp );
	fputs(		  "*\n" , fp );
	fprintf( fp , "*  Label file for %s\n" , filename );
	fputs(		  "*\n" , fp );
	fprintf( fp , "*		  DIS version %s\n" , Version );
	fputs(		  "*\n" , fp );
	fputs(		  "*********************************************\n" , fp );
}


/*

  xt@Cǂݍ

*/
extern void 	read_labelfile( filename )
char	*filename;
{
	FILE		*fp;
	char		linebuf[64] , *ptr;
	int 		line;
	int 		pass;
	address 	adrs;
	int 		attr;
	char		symstr[64];

	if( ( fp = fopen( filename , "r" ) ) == NULL ) {
		err( 1 , "\n%s I[vł܂łB\n" , filename );
		return;
	}

	for( pass = 0 ; pass < 2 ; pass++ ) {
		if( Debug & BDEBUG )
			printf( "pass %d\n" , pass );
		for( line = 1 ; ; line++ ) {
			if( fgets( linebuf , 64 , fp ) == NULL )
				break;
			linebuf[ strlen( linebuf ) - 1 ] = '\0';
			for( ptr = linebuf ; ( *ptr == ' ' || *ptr == '\t' ) && *ptr != '\0' ; ptr++ )
				;
			if( *ptr != '\n' && *ptr != '*' && *ptr != '\0' ) {
				if( ( attr = getline( ptr , line , pass , &adrs , symstr ) ) != -1 )
					work( adrs , attr , symstr , pass , line );
				if( pass == 0 && symstr[0] )
					add_symbol( adrs , 3 , symstr );
			}
		}
		if( pass == 0 )
			rewind( fp );
	}
	fclose( fp );
}


/*

  xt@ĈPs͂

  pass = 0, 啶̂ݔ
  1, ̂ݔ

  */
#define skipspace\
{ while( ( *ptr == ' ' || *ptr == '\t' ) && *ptr != '\0' ) ptr++;}
#define untilspace\
{ while( *ptr != ' ' && *ptr != '\t' && *ptr != '\0' ) ptr++; }

private int 	getline( linebuf , line , pass , adrs , symstr )
char	*linebuf;
int 			line;
int 			pass;
address *adrs;
char	*symstr;
{
	address 	ad;
	char		*ptr = linebuf;
	opesize 	attr = 0;
	int 		symlen;

	ad = (address)atox( linebuf );
	untilspace;
	skipspace;
	if( Debug & BDEBUG )
		printf( "%x , %c\n" , ad , *ptr );

	if( pass == 0 && islower( *ptr ) || pass == 1 && isupper( *ptr ) ) {
		attr = -1;
	} else {
		switch( toupper( *ptr ) ) {
		case 'P' :
			attr = PROLABEL;
			break;
		case 'D' :
			attr = DATLABEL;
			switch( toupper( *++ptr ) ) {
			case 'S' :
				attr |= STRING;
				break;
			case 'R' :
				attr |= RELTABLE;
				if( toupper( ptr[1] ) == 'L' ){
					ptr++;
					attr &= ~RELTABLE;
					attr |= RELLONGTABLE;
				}
				break;
			case 'Z' :
				attr |= ZTABLE;
				break;
			case 'B' :
				attr |= BYTESIZE;
				break;
			case 'W' :
				attr |= WORDSIZE;
				break;
			case 'L' :
				attr |= LONGSIZE;
				break;
			case 'U' :
				attr |= UNKNOWN;
				break;
			default:
				goto er;
			}
			break;
		default:
		er:
			err( 1 , "\nlabelfile %ds address %x : sȕł\n" , line , ad );
		}
		if( toupper( *++ptr ) == 'F' )
			attr |= FORCE;
	}
	untilspace;
	skipspace;
	symstr[0] = 0;
	if( *ptr != '\0' && *ptr != '*' ) {
		symlen = min( strcspn( ptr , " \t\n*" ) , 31 );
		strncpy( symstr , ptr , symlen );
		symstr[ symlen ] = '\0';
	}

	*adrs = ad;
	return attr;
}


private void	work( adrs , attr , symstr , pass , line )
address adrs;
int 			attr;
char	*symstr;
int 			pass;
int 			line;
{
	switch ( pass ) {
	case 0 :
		if( !regist_label( adrs , attr ) )
			err( 0 , "??? %ds address %x\n" , line , adrs );
		break;
	case 1 :
		if( isPROLABEL( attr ) ) {
			if( Debug & BDEBUG )
				printf( "work:prog %x\n" , adrs );
			if( !analyze( adrs , ANALYZE_IGNOREFAULT ) )
				err( 0 , "\nAddress %x(labelfile Line %d)̓vOƌȂ܂" ,
					 adrs , line );
		} else {
			switch( attr & 0xff ) {
			case RELTABLE :
				relative_table( adrs );
				break;
			case RELLONGTABLE :
				relative_longtable( adrs );
				break;
			case ZTABLE :
				z_table( adrs );
				break;
			default:
				if( !regist_label( adrs , attr ) )
					err( 0 , "\n??? labelfile %ds address %x" , line , adrs );
				break;
			}
		}
	}
}

