/* $Id: output.c,v 1.1 1996/11/07 08:03:56 ryo freeze $
 *
 *	\[XR[hWFl[^
 *	o̓[`
 *	Copyright (C) 1989,1990 K.Abe
 *	All rights reserved.
 *
 */

#include	<stdio.h>
#include	<string.h>
#if !defined( STREAM ) && !defined( MYU_HEADERS )
	#include	<fcntl.h>
	#ifndef unix
	#include	<stat.h>
	#include	<io.h>
	#endif
#endif
#ifdef unix
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/file.h>
#endif
#include	"estruct.h"
#include	"global.h"
#include	"etc.h"		/* err */
#include	"output.h"
#include	"disasm.h"
#include	"generate.h"	/* Atab */
#include	"hex.h"		/* strend */

USEOPTION	option_a , option_S;
extern	char	CommentChar;

/* private ֐vg^Cv */
private void	output_through_buffer( char* );
private void	flush_buffer( void );

int		Output_AddressCommentLine;
int		Output_SplitByte;

#ifdef STREAM
static FILE	*Output_fp;
#else
static int	Output_handle;
static char	*OutputLargeBuffer = NULL;
static char	*OutputLargeBufferPtr;
#endif
static char	OutputBuffer[256];
static char	*OutputBufferEnd = OutputBuffer;
static char	FilenameBody[PATH_MAX];
static boolean	SplitMode;

#define	OUTPUT_BUFFER_SIZE	(64*1024)


/*

  

*/
extern void	init_output()
{
#ifndef STREAM
    if( ( OutputLargeBuffer = Malloc( OUTPUT_BUFFER_SIZE ) ) == NULL )
	err( 1 , "o̓obt@pmۏo܂\n" );
    OutputLargeBufferPtr = OutputLargeBuffer;
#endif
}


/*

  o̓t@CI[v

*/
extern void	output_file_open( filename , file_block_num )
char	*filename;
int	file_block_num;
{
    char	tempfilename[PATH_MAX];

    strcpy( tempfilename , filename );

    if( !strcmp("-",filename) ){

#ifdef STREAM
	Output_fp = stdout;
#else
	Output_handle = STDOUT;
#endif

    }else{
	if( option_S ) {
	    switch( file_block_num ) {
	    case 0:
		strcpy( FilenameBody , filename );
		strcat( tempfilename , ".000" );
		SplitMode = TRUE;
		break;
	    case -1:
		strcat( tempfilename , ".DAT" );
		SplitMode = FALSE;
		break;
	    case -2:
		strcat( tempfilename , ".BSS" );
		SplitMode = FALSE;
		break;
	    default:
		sprintf( strend( tempfilename ) , ".%03X" , file_block_num );
	    }
	}

#ifdef	STREAM
	if( ( Output_fp = fopen( tempfilename , "w" ) ) == NULL )
	    err( 1 , "%s I[vo܂(temp)\n" , tempfilename );
#else
#ifdef	OSK
	if( ( Output_handle = creat( tempfilename , S_IREAD | S_IWRITE ) ) < 0 )
	    err( 1 , "%s I[vo܂\n" , tempfilename );
#else
	if( ( Output_handle =
	  open( tempfilename ,
	        O_CREAT | O_WRONLY | O_TRUNC | O_BINARY , S_IRUSR|S_IWUSR ) ) < 0 )
	    err( 1 , "%s I[vo܂(temp)\n" , tempfilename );
#endif	/* OSK	*/
#endif

    }
}


extern void	output_file_close()
{
#ifdef STREAM
    fclose( Output_fp );
#else
    flush_buffer();
    close( Output_handle );
#endif
}


/*

  ݃G[

*/
private void	diskfull()
{
#ifdef STREAM
    fclose( Output_fp );
#else
    close( Output_handle );
#endif
    err( 1 , "\nfBXNtł\n" );
}


/*

  t@C֏o

*/
#ifdef	OSK
extern void	outputf( fmtstr , arg1, arg2, arg3 )
char	*fmtstr;
long	arg1, arg2, arg3;
{
#ifdef STREAM
    fprintf( Output_fp , fmtstr , arg1 , arg2 , arg3 );
    if( ferror( Output_fp ) )
	diskfull();
#else
    char	tmp[256];

    sprintf( tmp , fmtstr , arg1 , arg2 , arg3 );
    output_through_buffer( tmp );
#endif
}
#else
extern void	outputf( fmtstr , args )
char	*fmtstr;
long	args;
{
	long	*arg;

#ifdef STREAM
	arg = &args;
	fprintf( Output_fp , fmtstr , arg[0] , arg[1] , arg[2] );
	if( ferror( Output_fp ) )
	diskfull();
#else
	char	tmp[256];

	arg = &args;
	sprintf( tmp , fmtstr , arg[0] , arg[1] , arg[2] );
	output_through_buffer( tmp );
#endif
}
#endif	/* OSK	*/

#if 0
/* this function is no longer used */
extern void	output( str )
char	*str;
{
    fputs( str , Output_fp );
    if( ferror( Output_fp ) )
	diskfull();
}
#endif /* 0 */


extern void	outputa( str )
char	*str;
{
    strcpy( OutputBufferEnd , str );
    OutputBufferEnd = strend( OutputBuffer );
}


#if 0
/* this function is no longer used */
extern void	outputc( ch )
int	ch;
{
    fputc( (char)ch , Output_fp );
}
#endif /* 0 */


extern void	outputca( ch )
int	ch;
{
    *OutputBufferEnd++ = ch;
    *OutputBufferEnd   = '\0';
}


#ifdef	OSK
extern void	outputfa( fmtstr , arg1, arg2, arg3 )
char	*fmtstr;
long	arg1, arg2, arg3;
{
    sprintf( OutputBufferEnd , fmtstr , arg1, arg2, arg3 );
    OutputBufferEnd = strend( OutputBuffer );
}
#else
extern void	outputfa( fmtstr , args )
char	*fmtstr;
long	args;
{
    long	*arg;

    arg = &args;

    sprintf( OutputBufferEnd , fmtstr , arg[0] , arg[1] , arg[2] );
    OutputBufferEnd = strend( OutputBuffer );
}
#endif	/* OSK	*/


extern void	outputax( num , width )
ULONG	num;
int	width;
{
    itox( OutputBufferEnd , num , width );
    OutputBufferEnd = strend( OutputBuffer );
}


extern void	outputaxd( num , width )
ULONG	num;
int	width;
{
    itoxd( OutputBufferEnd , num , width );
    OutputBufferEnd = strend( OutputBuffer );
}


extern void	outputax2_without_0supress( num )
ULONG	num;
{
    itox2_without_0supress( OutputBufferEnd , num );
    OutputBufferEnd = strend( OutputBuffer );
}


extern void	newline( lineadrs )
address	lineadrs;
{
    static int	linecount = 1;
    static int	file_block_num = 0;
    int		i , len;
    char	*ptr;

    if( option_S && SplitMode ) {
	if( Output_SplitByte <=
	    (long)lineadrs - (long)BeginTEXT - Output_SplitByte * file_block_num &&
#ifdef STREAM
	    OutputBuffer[0] == '\n'
#else
	    OutputBuffer[0] == '\n'
#endif
	    ) {
	    file_block_num++;
	    output_file_close();
	    output_file_open( FilenameBody , file_block_num );
	}
    }

    if( option_a ) {
		if( linecount >= Output_AddressCommentLine ) {
			for( ptr = OutputBuffer , len = 0 ; *ptr ; ptr++ ) {
				switch( *ptr ) {
				case '\t':
					len += 8 - len % 8;
					break;
				case '\n':
					len = 0;
					break;
				default:
					len++;
					break;
				}
			}

		    for( i = Atab - len / 8 - 1 ; i > 0 ; i-- )
			*OutputBufferEnd++ = '\t';
			*OutputBufferEnd++ = '\t';
			*OutputBufferEnd++ = CommentChar;

		    OutputBufferEnd = itox6( OutputBufferEnd, (ULONG)lineadrs );
		    linecount = 1;
		}else{
			linecount++;
		}
	}

#ifdef	OSK
    *OutputBufferEnd++ = '\n';
#else
#ifdef STREAM
    *OutputBufferEnd++ = '\n';
#else
    *OutputBufferEnd++ = '\n';
#endif
#endif	/* OSK	*/
    *OutputBufferEnd   = '\0';

#ifdef STREAM
    fputs( OutputBuffer , Output_fp );
    if( ferror( Output_fp ) )
	diskfull();
#else
    output_through_buffer( OutputBuffer );
#endif
    OutputBufferEnd = OutputBuffer;
}


#ifndef STREAM
private void	output_through_buffer( str )
char	*str;
{
    strcpy( OutputLargeBufferPtr , str );
    OutputLargeBufferPtr = strend( OutputLargeBufferPtr );

    if( OutputLargeBufferPtr - OutputLargeBuffer > OUTPUT_BUFFER_SIZE - 1024 )
	flush_buffer();
}


private void	flush_buffer()
{
    long	length = OutputLargeBufferPtr - OutputLargeBuffer;

    if( write( Output_handle , OutputLargeBuffer , length ) < length ) {
	diskfull();
    }
    OutputLargeBufferPtr = OutputLargeBuffer;
}
#endif /* STREAM */
