/* $Id: symbol.c,v 1.1 1996/11/07 08:04:02 ryo freeze $
 *
 *		\[XR[hWFl[^
 *		V{l[ǗW[
 *		Copyright (C) 1989,1990 K.Abe
 *		All rights reserved.
 *
 */

#include		<stdio.h>
#include		<string.h>
#include		"estruct.h"
#include		"global.h"
#include		"etc.h"
#include		"symbol.h"
#include		"label.h"


int 			Symbolbufsize;			/* V{obt@̐ */
static symbol	*Symtable = NULL;		/* V{e[u̓ */
static int		Symnum; 				/* V{e[u̗vf */

static const_symbol	*ConstSymtable = NULL;		/* V{e[u̓ */
static int			ConstSymnum;				/* V{e[u̗vf */


/*#define		DEBUG*/
extern void 	init_symtable()
{
	if( (( Symtable  = (symbol *)Malloc( Symbolbufsize * sizeof( symbol ) ) ) == NULL) ||
		(( ConstSymtable = (const_symbol *)Malloc( Symbolbufsize * sizeof( const_symbol ) ) ) == NULL ) )
		err( 1 , "V{e[uobt@mۏo܂ł\n" );

	Symnum = 0;
	ConstSymnum = 0;
}


extern void 	make_symtable()
{
	char		*ptr;			/* V{\ւ̃|C^ */
	int 		type;

	ptr = (char*)( Top + Head.text + Head.data + Head.offset );
	while( (ULONG)ptr < (ULONG)( Top + Head.text + Head.data + Head.offset + Head.symbol ) ) {
		type = *(UWORD*)ptr;
		add_symbol( *(address*)( ptr + 2 ) , type , ptr + 6 );
		if( type >= 0x201 || type == 3 )
			regist_label( *(address*)( ptr + 2 ) , DATLABEL | UNKNOWN );

		for( ptr += 6 ; *ptr != 0 ; ptr++ );
		ptr++;
		ptr += (long)ptr & 1;
	}
}


/*

  n

*/
extern void 	free_symbuf()
{
	if( Symtable != NULL )
		Mfree( Symtable );

	if( ConstSymtable != NULL )
		Mfree( ConstSymtable );
}


/*

  adrs V{e[u{
  adrs  common text data bss ̂ꂩ
  |C^AłȂ NULL Ԃ

*/
extern symbol	*symbol_search( adrs )
address adrs;
{
	int 		step = Symnum >> 1;
	symbol		*ptr = Symtable;

	while( step > 4 ) {
		if( ( ptr + step )->adrs <= adrs )						/* binary search */
			ptr += step;
		step >>= 1;
	}
	for( ; ptr < Symtable + Symnum ; ptr++ ) {
		if( ptr->adrs == adrs )
			return ptr;
		else
			if( adrs < ptr->adrs )
				return NULL;
	}
	return NULL;
}


extern void 	add_constsymbol( adrs , symstr )
address	adrs;
char	*symstr;
{
	int i;
	i = ConstSymnum;

	ConstSymtable[i].adrs = adrs;
	strncpy( ConstSymtable[i].sym , symstr , 32 );

	if( ++ConstSymnum >= Symbolbufsize )
		err( 1 , "V{e[uӂ܂\n" );
}


extern void 	add_symbol( adrs , type , symstr )
address adrs;
int 			type;
char	*symstr;
{
	int 		i;


	if( type < 0x201 && type != 3 ){
		add_constsymbol( adrs, symstr );
		return;
	}


	for( i = Symnum - 1 ; Symtable[ i ].adrs > adrs && i >= 0 ; i-- )
		Symtable[ i + 1 ] = Symtable[ i ];

	if( i >= 0 && Symtable[ i ].adrs == adrs )
		return;

	i++;
	Symtable[ i ].type = (UWORD)type;
	Symtable[ i ].adrs = adrs;
	strncpy( Symtable[ i ].sym , symstr , 32 );


#ifdef	DEBUG
	printf( "type %4x adrs %6x sym:%s\n" , Symtable[ i ].type ,
		   Symtable[ i ].adrs , Symtable[ i ].sym );
#endif

	if( ++Symnum >= Symbolbufsize )
		err( 1 , "V{e[uӂ܂\n" );
}




extern boolean	is_exist_symbol()
{
	return Symnum ? TRUE : FALSE;
}




extern int	get_constsymbol_num()
{
	return ConstSymnum;
}

extern const_symbol *get_constsymbol( i )
int i;
{
	return ConstSymtable + i;
}

