/* $Id: table.c,v 1.1 1996/10/24 04:27:40 ryo freeze $
 *
 *		\[XR[hWFl[^
 *		e[uW[
 *		Copyright (C) 1989,1990 K.Abe
 *		All rights reserved.
 *
 */
#include		<stdio.h>

#ifndef unix
#	ifdef MYU_HEADERS
#		include		<ctype.h>		/* tolower */
#	else
#		include		<fctype.h>		/* ctype is bad because macro expansion */
									/* causes twice evaluation. */
#	endif
#else
#	include		<unistd.h>
#	include		<ctype.h>
#endif

#include		<string.h>
#include		<stdlib.h>		/* atoi */
#include		"estruct.h"
#include		"global.h"
#include		"label.h"
#include		"labelfile.h"
#include		"etc.h"
#include		"table.h"
#include		"offset.h"		/* depend_address */
#include		"hex.h" 		/* strend */

USEOPTION		option_q;

extern int		strncmpi( char* , char* , int );
extern int		Quiet_mode;

static struct _table	Table[ MAX_TABLE_NUM ];
static int		TableCounter = 0;

static int		Line_num = 0;

private void	interpret( table * );
private void	tablejob( address , FILE * );
private void	interpret_all( void );

/* table.loop mode */
#define TIMES_AUTOMATIC 		0
#define TIMES_DECIDE_BY_BREAK	-1
#define fprintfq if( option_q && Quiet_mode < 1 )fprintf

#define debug	if(0)printf

/*

  e[uLqt@Cǂݍ

*/
extern void 	read_tablefile( filename )
char	*filename;
{
	FILE		*fp;
	char		linebuf[256];
	address 	tabletop;

	if( ( fp = fopen( filename , "r" ) ) == NULL ) {
		err( 1 , "\n%s I[vł܂łB\n" , filename );
		return;
	}

	while( 1 ) {
		fgets( linebuf , 250 , fp );
		if( feof( fp ) )
			break;
		Line_num++;
		if( linebuf[0] == '#' || linebuf[0] == '*' )			/* comment */
			continue;
		if( isxdigit( linebuf[0] ) ) {
			tabletop = (address)atox( linebuf );
			fprintfq( stderr, "Table(%x)\n" , tabletop );
			tablejob( tabletop , fp );
		}
	}
	interpret_all();
	fclose( fp );
}


/*

  e[ȕ

  */
private void	tablejob( tabletop , fp )
address tabletop;
FILE	*fp;
{
	struct _formula 	*cur_expr;
	int 				formula_line = 0;
	char				linebuf[256];

	regist_label( tabletop , DATLABEL|TABLE|FORCE );

	Table[ TableCounter ].tabletop = tabletop;
	if( ( cur_expr = malloc( sizeof( struct _formula ) * MAX_TABLE_LINE ) ) == NULL )
		err( 1 , "e[uLpobt@mۏo܂łB\n" );

	while( 1 ) {
		if( fgets( linebuf , 250 , fp ) == NULL )
			err( 1 , "Table  EOF ɒB܂\n" );

		if( *( strend( linebuf ) - 1 ) == '\n' )
			*( strend( linebuf ) -1 ) = '\0';
		Line_num++;
		if( linebuf[0] == '#' || linebuf[0] == '*' )			/* comment */
			continue;

		if( strncmpi( linebuf , "end" , 3 ) == 0 ) {
			char		*ptr;
			for( ptr = linebuf + 3 ; *ptr == ' ' || *ptr == '\t' ; ptr++ )
				;
			if( *ptr == '[' ) {
				for( ptr++ ; *ptr == ' ' || *ptr == '\t' ; ptr++ )
				;
				if( isdigit( *ptr ) ) {
					Table[ TableCounter ].loop = atoi( ptr );
					break;
				} else if( strncmpi( ptr , "breakonly" , 9 ) == 0 ) {
					/* e[u break ݂̂Ŕf */
					Table[ TableCounter ].loop = TIMES_DECIDE_BY_BREAK;
					break;
				} else if( *ptr == ']' ) {
					Table[ TableCounter ].loop = TIMES_AUTOMATIC;
					/* w肳Ȃ ->  */
					break;
				}
				err( 1 , "Syntax error at end(%d s)\n" , Line_num );
			} else
				Table[ TableCounter ].loop = 1;
			break;
		} else {		/* if( strncmpi( linebuf , "end" , 3 ) != 0 ) */
			cur_expr[ formula_line ].line = Line_num;
			strcpy( cur_expr[ formula_line ].expr , linebuf );
			if( ++formula_line > MAX_TABLE_LINE )
				err( 1 , "TABLE ̍s܂B\n" );
		}
	}

	cur_expr = Realloc( cur_expr , sizeof( struct _formula ) * formula_line );
	Table[ TableCounter ].formulaptr = cur_expr;
	Table[ TableCounter ].lines 	 = formula_line;
	if( ++TableCounter >= MAX_TABLE_NUM )
		err( 1 , "TABLE  %d z܂B\n" , MAX_TABLE_NUM );
}


private void	interpret_all()
{
	int 		i;

	for( i = 0 ; i < TableCounter ; i++ )
		interpret( &Table[ i ] );
}


private void	interpret( table_ptr )
table	*table_ptr;
{
	struct _formula 	*cur_expr = table_ptr->formulaptr;
	address 			pc0 = 0;
	int 				i;
	int 				loop = 0;
	lblbuf				*lblptr = NULL;
	extern int			yyparse( void );

	Eval_TableTop = Eval_PC = table_ptr->tabletop;
	ParseMode = PARSE_ANALYZING;

	if( BeginBSS <= Eval_PC )
		return;

	do {
		for( i = 0 ; i < table_ptr->lines ; i++ ) {
			Eval_Count = 0; 			/* First, Eval_Count is set in yyparse() */
			do {
				Lexptr = cur_expr[ i ].expr;
				fprintfq( stderr, "[%d:%06x]:%s\n" , loop + 1 , Eval_PC , Lexptr );
				if( yyparse() == 1 )
					err( 1 , "Syntax error (%d s)\n" , cur_expr[ i ].line );

				cur_expr[ i ].id = Eval_ID;
				pc0 = Eval_PC;

				if( depend_address( Eval_PC ) &&
					Eval_ID != LONGSIZE && Eval_ID != EVENID &&
#if 0
					Eval_ID != LONGID &&
#endif
					Eval_ID != BREAKID	&& Eval_ID != CRID ) {
					if( table_ptr->loop == TIMES_AUTOMATIC ) {
						debug( "depend chk" );
						goto tableend;
					}
					err( 1 , "AhXˑŃO[hw肳Ă܂(%x)\n" ,
						 Eval_PC );
				}
				switch( Eval_ID ) {
				case LONGSIZE:
					if( (long)Eval_PC & 1 )
						err( 0 , "Warning: AhX(%x)ŃO[hw肳Ă܂\n" ,
							Eval_PC );
					Eval_PC += 4;
					break;
				case WORDSIZE:
					if( (long)Eval_PC & 1 )
						err( 0 , "Warning: AhX(%x)Ń[hw肳Ă܂\n" ,
							 Eval_PC );
					Eval_PC += 2;
					break;
				case BYTESIZE:
					Eval_PC++;
					break;
#if 0
				case LONGID:
					if( (long)Eval_PC & 1 )
						err( 0 , "Warning: AhX(%x)ŃO[hw肳Ă܂\n" ,
							 Eval_PC );
					Eval_PC += Eval_Bytes*4;
					break;
				case WORDID:
					if( (long)Eval_PC & 1 )
						err( 0 , "Warning: AhX(%x)Ń[hw肳Ă܂\n" ,
							 Eval_PC );
					Eval_PC += Eval_Bytes*2;
					break;
#endif
				case BYTEID:			/* fall through to ASCIIID */
				case ASCIIID:
					Eval_PC += Eval_Bytes;
					break;
				case ASCIIZID:
					for( ; *(char*)( Eval_PC + Ofst ) != 0 ; Eval_PC++ )
						;
					Eval_PC++;
					break;
				case LASCIIID:
					Eval_PC += *(unsigned char*)( Eval_PC + Ofst ) + 1;
					break;
				case EVENID:
					Eval_PC += ( (long)Eval_PC & 1 );
					break;
				case CRID:
					break;
				case BREAKID:
					if( Eval_Break ) {
						debug( "break" );
						loop++;
						goto tableend;
					}
					break;
				default:		/* reduce warning message */
					;
				}

				if( Eval_PC > BeginBSS ||
					( table_ptr->loop == TIMES_AUTOMATIC &&
					 ( ( lblptr = next( pc0 + 1 ) ) == NULL ||
					  Eval_PC >= lblptr->label ) ) ) {
					loop++;
					if( Eval_PC > lblptr->label )
						Eval_PC = pc0;
					debug( "exceeded next label" );
					goto tableend;
				}

				/* if( Eval_ID != BREAKID && Eval_ID != CRID ) {
					   if( !regist_label( pc0 , DATLABEL | Eval_ID ) )
						   err( 0 , "??? address %x" , pc0 );
				   } */
				Eval_Count--;
			} while( Eval_Count > 0 );
		}
		loop++;
	}while( Eval_PC < BeginBSS &&
			 ( table_ptr->loop == TIMES_AUTOMATIC &&
			  ( lblptr = next( pc0 + 1 ) ) != NULL &&
			  Eval_PC < lblptr->label )
			 || table_ptr->loop == TIMES_DECIDE_BY_BREAK
			 || table_ptr->loop != TIMES_AUTOMATIC && loop < table_ptr->loop );

tableend:
	fprintfq( stderr, "Table  %x - %x (%d)Ɣf܂\n" ,
			Eval_TableTop , Eval_PC , loop );
	if( !regist_label( Eval_PC , DATLABEL|ENDTABLE|UNKNOWN ) ) {
		/* printf( "??? address %x\n" , Eval_PC ); */
		;
	}
	if( table_ptr->loop == TIMES_AUTOMATIC || table_ptr->loop == TIMES_DECIDE_BY_BREAK )
		table_ptr->loop = loop; 				/* set implicit loop times */
}


/*

  e[ũT[`

*/
extern table	*search_table( pc )
address pc;
{
	int 		i;

	for( i = 0 ; i < TableCounter ; i++ ) {
		if( Table[ i ].tabletop == pc )
			return &Table[ i ];
	}
	return NULL;
}
